#include "binaryfile.h"
#include <stdexcept>

BinaryFile::BinaryFile ( const char *fname ) : m_data ( 0 ), m_dataLen ( 0 )
{
    FILE *pFile;
    size_t lSize;
    char *buffer;
    size_t result;

    pFile = fopen ( fname, "rb" );
    if ( pFile == NULL )
        return;

    fseek ( pFile , 0 , SEEK_END );
    lSize = ftell ( pFile );
    rewind ( pFile );

    buffer = ( char* ) malloc ( sizeof ( char ) * lSize );
    if ( buffer == NULL )
        return;

    result = fread ( buffer, 1, lSize, pFile );
    if ( result != lSize )
    {
        if ( !feof ( pFile ) )
            return;
    }

    fclose ( pFile );

    m_data = buffer;
    m_dataLen = lSize;
}

BinaryFile::~BinaryFile()
{
    if ( m_data )
        free ( m_data );
}

const char *BinaryFile::getData()
{
    return ( const char * ) m_data;
}

size_t BinaryFile::getDataLen()
{
    return m_dataLen;
}
