#ifndef CHAINBOX_H
#define CHAINBOX_H

#include <vector>
#include <wx/listbox.h>
#include <wx/string.h>

class ChainBox : public wxListBox
{
public:
    ChainBox ( wxWindow *parent, int id, const std::vector<wxString> &v );
    void getChainVector ( std::vector<wxString> *chainVector );
    void clear();
    void clone();
    void loadState( const wxString& state );
    void moveDown();
    void moveUp();
    void remove();
    void restore();
    bool getUpdateDelete();
    bool hasSelection();
    wxString saveState();
private:
    std::vector<wxString> chainVector;
};

#endif
