#include <wx/stdpaths.h>
#include <wx/filename.h>
#include <wx/utils.h>
#include "dir.h"

//eal
#include <wx/wx.h>

wxString Dir::getBinaryDir()
{
    wxString binaryDir = wxStandardPaths::Get().GetExecutablePath();
    wxString drive, directory;
    wxFileName::SplitPath ( binaryDir, &drive, &directory, NULL, NULL );
    return
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory +
        wxFileName::GetPathSeparator();
}

wxString Dir::getAppDir()
{
    wxString appPath = wxStandardPaths::Get().GetExecutablePath();
    wxString drive, directory;
    wxFileName::SplitPath ( appPath, &drive, &directory, NULL, NULL );
    return
#ifdef __WXMSW__
        drive + _T(":") +
        directory +
#else
        directory +
        wxFileName::GetPathSeparator() +
        _T("..") +
        wxFileName::GetPathSeparator() +
        _T("share") +
        wxFileName::GetPathSeparator() +
        _T("smasher") +
#endif
        wxFileName::GetPathSeparator();
}

wxString Dir::getSamplesDir()
{
    wxString s = getAppDir() + _T("samples") + wxFileName::GetPathSeparator();
    return s;
}

wxString Dir::getPresetsDir()
{
    wxString s = getAppDir() + _T("presets") + wxFileName::GetPathSeparator();
    return s;
}

wxString Dir::getCsdDir()
{
    wxString s = getAppDir() + _T("csd") + wxFileName::GetPathSeparator();
    return s;
}

wxString Dir::getDataDir()
{
    wxString s = wxStandardPaths::Get().GetUserConfigDir()/*GetUserDataDir()*/ + wxFileName::GetPathSeparator();
    return s;
}
