#ifndef EFFECTSGRID_H
#define EFFECTSGRID_H

#include <vector>

#include <wx/string.h>
class wxWindow;

#include "monochromegrid.h"

class EffectsGrid : public MonochromeGrid
{
public:
    EffectsGrid ( wxWindow *parent, int id, const std::vector<wxString> &v,
                  size_t colNo, int cellHeight, int cellWidth = -1, bool verticalConstraint = false );
    void createRandomPositionVector ( std::vector<size_t>& positionVector, size_t length );
    void getNamedPositionVector ( wxString name, std::vector<size_t>& positionVector );
    void setNamedPositionVector ( wxString name, std::vector<size_t>& positionVector );
    void getEffectsVector ( std::vector<wxString>& effectsVector );
private:
    int getEffectsRowNumber ( wxString name );
    std::vector<wxString> effectsVector;
};


#endif
