#ifndef FUNCTOR_H
#define FUNCTOR_H

#include "fftreal/def.h"

double heavySideStepFunction ( double d );
double rect ( double d );
double square ( double d );
double aaSquare ( double d );

double passThrough ( double d1, double d2, double d3 );
double passThrough ( double d1, double d2 );
double passThrough ( double d1 );

double rConvexSoftClipper ( double toClip, double start, double end );
double rConcaveSoftClipper ( double toClip, double start, double end );

double lConvexSoftClipper ( double toClip, double start, double end );
double lConcaveSoftClipper ( double toClip, double start, double end );

double aaTriangleFunction ( double d );
double triangleFunction ( double d );
double aaTriangle ( double d );
double triangle ( double d );

double aaSawTooth ( double d );
double sawTooth ( double d );

double sinPlus ( double d );
double sinPow2 ( double d );

double sampleAndHold ( double d );

double sweepIn ( double f, double limit );
double sweepOut ( double f, double limit );

double resonance ( double x );

double fftLowpassFilter ( double f, double bandLo, double slopeLo, double bandHi, double slopeHi);
double fftHighpassFilter ( double f, double bandLo, double slopeLo, double bandHi, double slopeHi);
double fftBandpassFilter ( double f, double bandLo, double slopeLo, double bandHi, double slopeHi);
double fftBandstopFilter ( double f, double bandLo, double slopeLo, double bandHi, double slopeHi);

double b3Overdrive ( double d );
double flatResponse ( double d );
double seventiesFuzzguitar ( double d );
double tubeDrive ( double d );

/*double sinDistorted ( double d, double cutoff, double distortRange, double steepness );
double sinDistortedNp2Np1 ( double d );
double sinToSquare ( double d );
double arcTangentNonLinearity ( double d );
double cubicSoftClipper ( double d );
double cubicSoftClipping ( double d );
double arcTangentNonLinear ( double d);*/

#endif
