#include <wx/url.h>
#include <wx/msgdlg.h>
#include "httpresource.h"

bool HttpResource::load ( const wxString& url, wxString *buffer )
{
    if ( !buffer )
    {
        error = _T( "invalid buffer" );
        return false;
    }

    buffer->clear();

    wxURL connection ( url );

    if ( connection.GetError() != wxURL_NOERR )
    {
        error = _T( "can't connect" );
        return false;
    }

    wxYield();
    connection.GetProtocol().SetTimeout ( 5 );

    wxInputStream *inStream;
    inStream = connection.GetInputStream();

    if ( !inStream )
    {
        error = _T( "can't open stream" );
        return false;
    }

    wxChar c;
    while ( !inStream->Eof() )
    {
        c = inStream->GetC();
        if ( !inStream->LastRead() )
            break;
        buffer->Append ( c );
    }
    // tbd: delete inStream

    return true;
}

wxString HttpResource::getError()
{
    return error;
}
