#include <wx/mediactrl.h>
#include <wx/frame.h>
#include <wx/statusbr.h>
#include "looptimer.h"
#include "smasherMain.h"

LoopTimer::LoopTimer(
    wxFrame *frameParameter,
    wxMediaCtrl *mediaCtrlParameter,
    wxMediaCtrl *mediaCtrlParameterAltParameter,
    bool *loopStateParameter ) :
        frame ( frameParameter ),
        mediaCtrl ( mediaCtrlParameter ),
        mediaCtrlAlt ( mediaCtrlParameterAltParameter ),
        loopState ( loopStateParameter )
{
}

void LoopTimer::Notify()
{
    smasherFrame *sf = ( smasherFrame *)frame;

    if ( ! ( *loopState ) )
    {
        sf->setChangedWhilePlaying ( false );
        return;
    }

    /*if ( sf->getChangedWhilePlaying() )
    {
        sf->getCurrentMediaCtrl()->Stop();
        sf->setChangedWhilePlaying ( false );
        sf->DoPlaySmashed();
        return;
    }*/

    sf->swapMediaCtrls();
    sf->getCurrentMediaCtrl()->Play();
    sf->getAlternativeMediaCtrl()->Pause();
    sf->getAlternativeMediaCtrl()->Seek( 0 );

    sf->startLoopTimer();
}

