#ifndef MONOCHROMEGRID_H
#define MONOCHROMEGRID_H

#include "wx/wx.h"
#include "wx/grid.h"
#include <vector>

class MonochromeGrid : public wxGrid
{
public:
    MonochromeGrid ( wxWindow *parent, int id, size_t rowNo, size_t colNo, int cellHeight, int cellWidth = -1, bool verticalConstraint = true );
    void autoLabel ( );
    void clearAll ( );
    void clearRow ( int row );
    void clearCol ( int col );
    void getPositionVector ( std::vector<size_t>& positionVector );
    void loadState ( const wxString& state );
    void OnGridRangeSelect(wxGridRangeSelectEvent& event);
    void OnLabelLeftClick ( wxGridEvent &e );
    void OnLabelRightClick ( wxGridEvent &e );
    void OnLeftClick ( wxGridEvent &e );
    void OnLeftDClick ( wxGridEvent &e );
    void resizeCols ( int i );
    void resizeRows ( int i );
    void rotateLeft ( );
    void rotateRight ( );
    wxString saveState ();
    void setPositionVector ( const std::vector<size_t>& positionVector );
    void clearHighlight();
    bool isSelected ( int row, int col );
    void showRow ( const wxString& rowLabelText, bool show );
protected:
    void setValue ( bool value, int row, int col );
private:
    void toggleValue ( int row, int col );
    int cellHeight, cellWidth;
    bool verticalConstraint, horizontalConstraint;
    DECLARE_EVENT_TABLE()
};

#endif

