#ifndef PROGRESSGRID_H
#define PROGRESSGRID_H

#include <vector>
#include <utility>
#include <wx/string.h>
#include "monochromegrid.h"

class wxWindow;

class ProgressGrid : public MonochromeGrid
{
public:
    ProgressGrid ( wxWindow *parent, int id, int colNo, int cellHeight = 4, int cellWidth = (int) ( 16.0 / 9.0 * 16.0 ));
    void OnGridRangeSelect( wxGridRangeSelectEvent& e ) {
        e.Skip();
    };
    void OnLabelLeftClick ( wxGridEvent &e ) {
        e.Skip();
    };
    void OnLabelRightClick ( wxGridEvent &e ) {
        e.Skip();
    };
    void OnLeftClick ( wxGridEvent &e ) {
        e.Skip();
    };
    void OnLeftDClick ( wxGridEvent &e ) {
        e.Skip();
    };
    void setColumn( int col );
    void reset();
private:
    void clearGrid();
    void initColours();
    void setLabel( int col );
    int currentColumn, memoryColumn;
    std::vector<wxColour> colourVector;
    int colourVectorSize;
    std::pair<int, int> rangeMemory;
    DECLARE_EVENT_TABLE()
};


#endif
