#ifndef RATE_DIALOG_H
#define RATE_DIALOG_H

#include <wx/dialog.h>

class wxButton;
class wxComboBox;
class wxStaticText;
class wxTextCtrl;
class wxFont;

class RateDialog : public wxDialog
{
public:
    RateDialog (
        wxWindow *parent,
        const wxString& title,
        wxString& preset,
        wxString& author,
        wxString& passcode,
        wxString& email );
    ~RateDialog();
    void OnOk ( wxCommandEvent& e );
    void OnRegister ( wxCommandEvent& e );
private:
    wxString getRatingString ( size_t i );
    enum ids {
        ID_REGISTER
    };
    wxFont *unicodeFont;
    wxComboBox *rateComboBox;
    wxString preset, author, passcode, email;
    wxString *presetPtr, *authorPtr, *passcodePtr, *emailPtr;
    wxStaticText *authorLabel, *registerLabel, *passcodeLabel;
    wxTextCtrl *authorEdit, *registerEdit, *passcodeEdit;
    wxButton *rateButton, *cancelButton, *registerButton;
    DECLARE_EVENT_TABLE()
};

#endif
