#ifndef SAMPLEMATH_H
#define SAMPLEMATH_H

#include <vector>
#include <string>
#include "fftreal/def.h"
#define DOUBLE_SHRT_MAX 32767.0

class SampleMath
{
public:
    static short doubleToShort ( double d );
    static double shortToDouble ( short s );
    static double sign ( double d );
    static double amplitudeToDecibel ( double d );
    static double decibelToAmplitude ( double d );
    static bool isPeak ( double before, double current, double after );
    static double getGradient ( std::vector<std::pair<double,double> >& peakVector );
    static double getPeakLevel ( std::vector<double> *leftChannel, std::vector<double> *rightChannel );
    static double crushBits ( double d, double currentMax, double crushedMax );
    static void joinChannels ( const std::vector<double> *leftChannel, const std::vector<double> *rightChannel, std::vector<double> *slice );
    static void splitChannels ( const std::vector<double> *slice, std::vector<double> *leftChannel, std::vector<double> *rightChannel);
    static long getNextPower2 ( long l );
};

#endif
