#ifndef SHARE_DIALOG_H
#define SHARE_DIALOG_H

#include <wx/dialog.h>

class wxButton;
class wxStaticText;
class wxTextCtrl;

class ShareDialog : public wxDialog
{
public:
    ShareDialog (
        wxWindow *parent,
        const wxString& title,
        wxString& preset,
        wxString& author,
        wxString& passcode,
        wxString& email,
        const wxString& sample,
        const wxString& state );
    ~ShareDialog();
    void OnOk ( wxCommandEvent& e );
    void OnRegister ( wxCommandEvent& e );
private:
    enum ids {
        ID_REGISTER
    };
    wxString sample, state, preset, author, passcode, email;
    wxString *presetPtr, *authorPtr, *passcodePtr, *emailPtr;
    wxStaticText *titleLabel, *authorLabel, *registerLabel, *passcodeLabel;
    wxTextCtrl *titleEdit, *authorEdit, *registerEdit, *passcodeEdit;
    wxButton *shareButton, *cancelButton, *registerButton;
    DECLARE_EVENT_TABLE()
};

#endif
