#ifndef SLICEMUTETRANSFORMER_H
#define SLICEMUTETRANSFORMER_H

#include <vector>

#include "samplemath.h"
#include "slicetransformer.h"


template<class T>
class SliceMuteTransformer : public SliceTransformer<T>
{
public:
    SliceMuteTransformer ( size_t channelsParameter = 2 ) : channels ( channelsParameter ) { };
    void transform ( std::vector<T> *leftChannel, std::vector<T> *rightChannel );
    void transformChannel ( std::vector<T> *channel );
private:
    size_t channels;
};

template<class T>
void SliceMuteTransformer<T>::transform ( std::vector<T> *leftChannel, std::vector<T> *rightChannel )
{
    transformChannel ( leftChannel );
    transformChannel ( rightChannel );
}

template<class T>
void SliceMuteTransformer<T>::transformChannel ( std::vector<T> *channel )
{
    size_t channelSize = channel->size();
    for ( size_t i = 0; i < channelSize; i++)
        (*channel)[ i ] = 0.0;
}

#endif

