#ifndef SLICEREVERSETRANSFORMER_H
#define SLICEREVERSETRANSFORMER_H

#include <algorithm>

#include "slicetransformer.h"

template<class T>
class SliceReverseTransformer : public SliceTransformer<T>
{
public:
    SliceReverseTransformer( size_t channelsParameter = 2 ) : channels ( channelsParameter ) { }
    void transform ( std::vector<T> *leftChannel, std::vector<T> *rightChannel );
    void transformChannel ( std::vector<T> *channel );
private:
    size_t channels;
};

template<class T>
void SliceReverseTransformer<T>::transform ( std::vector<T> *leftChannel, std::vector<T> *rightChannel )
{
    transformChannel ( leftChannel );
    if ( rightChannel )
        transformChannel ( rightChannel );
}


template<class T>
void SliceReverseTransformer<T>::transformChannel ( std::vector<T> *channel )
{
    std::reverse( channel->begin(), channel->end() );
}
#endif
