#include <algorithm>
#include <ctime>
#include <iostream>
#include <fstream>
#include <memory>
#include <stdexcept>

#include <wx/aui/aui.h>
#include <wx/aboutdlg.h>
#include <wx/fileconf.h>
#include <wx/frame.h>
#include <wx/generic/aboutdlgg.h>
#include <wx/grid.h>
#include <wx/listctrl.h>
#include <wx/tglbtn.h>
#include <wx/wxhtml.h>

#include <wx/menu.h>
#include <wx/sizer.h>
#include <wx/sound.h>
#include <wx/spinctrl.h>
#include <wx/stdpaths.h>
#include <wx/textctrl.h>
#include <wx/treebook.h>
#include <wx/utils.h>
#include <wx/timer.h>
#include <wx/valtext.h>
#include <wx/url.h>
#include <wx/stream.h>

#include "appicon.h"
#include "binaryfile.h"
#include "chainbox.h"
#include "effectsgrid.h"
#include "monochromegrid.h"
#include "progressgrid.h"
#include "keymapper.h"
#include "mediatimer.h"
#include "looptimer.h"
#include "samplemath.h"
#include "settingsbook.h"
#include "sliceauxtransformer.h"
#include "slicebitcrushtransformer.h"
#include "slicecompresstransformer.h"
#include "slicedeclicktransformer.h"
#include "slicedelaytransformer.h"
#include "slicedelaypantransformer.h"
#include "slicedelayphasetransformer.h"
#include "slicedelayvariabletransformer.h"
#include "slicedistorttransformer.h"
#include "slicedownsampletransformer.h"
#include "sliceenhancetransformer.h"
#include "sliceeqtransformer.h"
#include "slicefadetransformer.h"
#include "sliceffttransformer.h"
#include "slicefftwindowedtransformer.h"
#include "slicegatetransformer.h"
#include "slicenormalizetransformer.h"
#include "slicepitchtransformer.h"
#include "sliceretriggertransformer.h"
#include "slicereversetransformer.h"
#include "slicereverbtransformer.h"
#include "slicetremolotransformer.h"
#include "slicetapestoptransformer.h"
#include "slicedelayphasetransformer.h"
#include "slicebpmtransformer.h"
#include "smashercopy.h"
#include "smashgridmapper.h"
#include "smashercriticalsectionlocker.h"
#include "smasherMain.h"
#include "smashthread.h"
#include "warpgrid.h"
#include "wav16smash.h"
#include "wavewindow.h"
#include "wraptempfilename.h"
#include "wrapcsound.h"
#include "replace.h"
#include "updatedialog.h"
#include "sharedialog.h"
#include "dir.h"
#ifndef __WXMSW__
#include "wraplibmad.h"
#endif

//#define SMASHER_DEBUG

#define USE_DOUBLE 1

BEGIN_EVENT_TABLE(smasherFrame, wxFrame)
    EVT_MEDIA_STATECHANGED(ID_MEDIACTRL, smasherFrame::OnMediaStateChanged)
    EVT_MEDIA_STATECHANGED(ID_MEDIACTRL_ALT, smasherFrame::OnMediaStateChanged)
    EVT_MEDIA_FINISHED(ID_MEDIACTRL, smasherFrame::OnMediaFinished)
    EVT_MEDIA_FINISHED(ID_MEDIACTRL_ALT, smasherFrame::OnMediaFinished)
    EVT_MEDIA_LOADED(ID_MEDIACTRL, smasherFrame::OnMediaLoaded)
    EVT_MEDIA_LOADED(ID_MEDIACTRL_ALT, smasherFrame::OnMediaLoaded)
    EVT_TIMER(ID_TIMER, smasherFrame::OnTimer)
    EVT_MENU(ID_LOOP, smasherFrame::OnLoop)
    EVT_CLOSE(smasherFrame::OnClose)
    EVT_IDLE(smasherFrame::OnIdle)
    EVT_MENU(ID_FX_ORDER_CLEAR, smasherFrame::OnFxOrderClear)
    EVT_MENU(ID_SAVE_SONG, smasherFrame::OnBuildSong)
    EVT_MENU(ID_FX_ORDER_STICKY, smasherFrame::OnFxOrderSticky)
    EVT_MENU(ID_PAUSE, smasherFrame::OnPause)
    EVT_MENU(ID_PLAY, smasherFrame::OnPlay)
    EVT_MENU(ID_PLAY_SMASHED, smasherFrame::OnPlaySmashed)
    EVT_MENU(ID_SHOW_LOG, smasherFrame::OnShowLog)
    EVT_MENU(ID_SHOW_SETTINGS, smasherFrame::OnShowSettings)
    EVT_MENU(ID_SHOW_TRANSPORT_ONLY, smasherFrame::OnShowTransportOnly)
    EVT_MENU(ID_SHOW_HELP, smasherFrame::OnShowHelp)
    EVT_MENU(ID_SLICE_ORDER_1_TO_N, smasherFrame::OnSliceOrder1ToN)
    EVT_MENU(ID_SLICE_ORDER_CLEAR, smasherFrame::OnSliceOrderClear)
    EVT_MENU(ID_SLICE_ORDER_N_TO_1, smasherFrame::OnSliceOrderNTo1)
    EVT_MENU(ID_SLICE_ORDER_SHUFFLE_ALL, smasherFrame::OnSliceOrderShuffleAll)
    EVT_MENU(ID_SLICE_ORDER_ROTATE_LEFT, smasherFrame::OnSliceOrderRotateLeft)
    EVT_MENU(ID_SLICE_ORDER_ROTATE_RIGHT, smasherFrame::OnSliceOrderRotateRight)
    EVT_MENU(ID_SLICE_ORDER_SHUFFLE_BY_KEY, smasherFrame::OnSliceOrderShuffleByKey)
    EVT_MENU(wxID_ABOUT, smasherFrame::OnAbout)
    EVT_MENU(wxID_EXIT, smasherFrame::OnQuit)
    EVT_MENU(ID_LOAD_MACHINE_STATE, smasherFrame::OnLoadMachineState)
    EVT_MENU(ID_SAVE_MACHINE_STATE, smasherFrame::OnSaveMachineState)
    EVT_MENU(ID_OPEN, smasherFrame::OnOpen)
    EVT_MENU(ID_SAVE, smasherFrame::OnSave)
    EVT_MENU(wxID_UNDO, smasherFrame::OnUndo)
    EVT_MENU(wxID_REDO, smasherFrame::OnRedo)
    EVT_MENU(ID_STOP, smasherFrame::OnStop)
    EVT_MENU(ID_RESTORE_DEFAULT, smasherFrame::OnRestoreDefault)
    EVT_MENU(ID_TOGGLE_PLAY, smasherFrame::OnTogglePlay)
    EVT_UPDATE_UI(wxID_REDO, smasherFrame::OnUpdateRedo )
    EVT_UPDATE_UI(wxID_UNDO, smasherFrame::OnUpdateUndo )
    EVT_UPDATE_UI_RANGE( ID_OPEN, ID_PLAY_SMASHED, smasherFrame::OnUpdateThreadRunning )
    EVT_UPDATE_UI_RANGE( ID_SHOW_LOG, ID_SHOW_SETTINGS, smasherFrame::OnUpdatePaneMaximized )
    EVT_SPINCTRL(ID_SLICE_NO_CHANGE, smasherFrame::OnSliceNoChange )
    EVT_AUI_PANE_CLOSE( smasherFrame::OnPaneClose)
    EVT_KEY_DOWN( smasherFrame::OnKeyDown )
    #ifndef __WXMSW__
    EVT_COMMAND_SCROLL( ID_VOLUME_SLIDER, smasherFrame::OnVolumeChanged )
    #else
    EVT_SPINCTRL( ID_VOLUME_SLIDER, smasherFrame::OnVolumeChanged )
    #endif
    EVT_TREEBOOK_PAGE_CHANGED(ID_SETTINGS_CHANGED, smasherFrame::OnSettingsChanged )
    EVT_GRID_LABEL_LEFT_CLICK( smasherFrame::OnGridColLeftClick )
    #ifdef __WXMSW__
    EVT_DROP_FILES ( smasherFrame::OnDropFiles )
    #endif
    EVT_MENU ( ID_CHECK_FOR_UPDATES, smasherFrame::OnCheckForUpdates )
    EVT_MENU ( ID_SHARE, smasherFrame::OnSharePreset )
    EVT_MENU_RANGE ( wxID_FILE1, wxID_FILE9, smasherFrame::OnHistoryFile )
END_EVENT_TABLE()

smasherFrame::smasherFrame( wxFrame *frame, const wxString& title ) :
        wxFrame(frame, -1, title, wxPoint (-1, -1), wxSize ( 1024, 768 )),
        config ( NULL ), thread ( NULL ),
        smashRequired ( false ), threadAbort ( false ), pathValid ( true ),
        alternativeCtrlIsCurrentCtrl ( false ), isPlaySmashedButton ( true ),
        helpPageLoaded ( false ),
        closeDown ( false ), changedWhilePlaying ( false ), presetLoaded ( false ),
        threadState ( SMASH_THREAD_INIT ), gridColumnMemory ( -1 ), logText ( NULL), redirect ( NULL )
{
    csoundInitialize ( NULL, NULL, CSOUNDINIT_NO_ATEXIT );

    csRefCounter = 0;

    prepareDataDir();
    config = new wxFileConfig (
#ifdef __WXMSW__
        _T( "smasher-config" )
#else
        _T( "smasher-config" )
#endif
    );

#ifdef __WXMSW__
    DragAcceptFiles( true );
#endif

#ifndef __WXMSW__
    SetFont ( *wxSMALL_FONT );
#endif

    wxString appPath = wxStandardPaths::Get().GetExecutablePath();
    wxString drive, directory;
    wxFileName::SplitPath ( appPath, &drive, &directory, NULL, NULL );
    appDir =
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory +
#ifndef __WXMSW__
        wxFileName::GetPathSeparator() +
        _T("..") +
        wxFileName::GetPathSeparator() +
        _T("share") +
        wxFileName::GetPathSeparator() +
        _T("smasher") +
#endif
        wxFileName::GetPathSeparator();

    wxString amenPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Amen_Break.wav");
    wxString guitarPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Guitar.wav");
    wxString electricGuitarPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Electric_Guitar.wav");
    wxString pianoPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Piano.wav");
    wxString tr808Path = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("TR-808.wav");
    wxString synthPath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Synth.wav");
    wxString sinePath = appDir + _T ( "samples" ) + wxFileName::GetPathSeparator() + _T ("Sine_Wave.wav");

    fileIn = amenPath;

    wxImage::AddHandler ( new wxPNGHandler );

    loopState = loopSmashedState = pauseState = slicePlayState = false;
    viewLogState = viewSettingsState = viewTransportOnlyState = orderStickyState = false;
    idleCounter = 0;

    fileMenu = new wxMenu(_T(""));
    updateFileMenu ( false );

    editMenu = new wxMenu(_T(""));
    editMenu->Append ( wxID_UNDO, _("&undo\tCtrl+Z"), _("undo") );
    editMenu->Append ( wxID_REDO, _("&redo\tCtrl+Y"), _("redo") );

    transportMenu = new wxMenu(_T(""));
    transportMenu->Append(ID_PLAY, _("&play\tF2"), _("play"));
    transportMenu->Append(ID_PLAY_SMASHED, _("&play smashed\tF3"), _("play smashed"));
    transportMenu->AppendCheckItem(ID_PAUSE, _("&pause\tF4"), _("pause"));
    transportMenu->Append(ID_STOP, _("&stop\tF5"), _("stop"));
    transportMenu->Append(ID_TOGGLE_PLAY, _("&toggle play\tSPACE"), _("toggle play"));
    transportMenu->AppendCheckItem(ID_LOOP, _("&loop\tF6"), _("loop"));
    viewMenu = new wxMenu(_T(""));
    viewMenu->AppendCheckItem(ID_SHOW_SETTINGS,_("&controls\tF9"), _("controls"));
#ifdef SMASHER_DEBUG
    viewMenu->AppendCheckItem(ID_SHOW_LOG,_("&log\tF11"), _("log"));
#endif
    viewMenu->AppendCheckItem(ID_SHOW_TRANSPORT_ONLY,_("&transport only\tCtrl+T"), _("transport only"));
    helpMenu = new wxMenu(_T(""));
    helpMenu->AppendCheckItem(ID_SHOW_HELP, _("&help\tF1"), _("show/hide help"));
    helpMenu->Append(ID_CHECK_FOR_UPDATES, _("&check for updates"), _("check for updates") );
    helpMenu->Append(wxID_ABOUT, _("&about"), _("show info about this application"));

    wxMenuBar* mbar = new wxMenuBar();
    mbar->Append(fileMenu, _("&file"));
    mbar->Append(editMenu, _("&edit"));
    mbar->Append(transportMenu, _("&transport"));
    mbar->Append(viewMenu, _("&view"));
    mbar->Append(helpMenu, _("&help"));
    SetMenuBar(mbar);

    int fields = STATUS_END - STATUS_MAIN;
    wxStatusBar *status = CreateStatusBar( fields );
    int widthArray[5] = { -1, 85, 85, 85, 85 };
    status->SetStatusWidths ( fields, widthArray );

    size_t bitmapSize = 24;
    wxBitmap openIcon, saveIcon, pauseIcon, playIcon, stopIcon, loopIcon, playSmashedIcon, undoIcon, redoIcon,
    order1ToNIcon, orderNTo1Icon, orderRotateLeftIcon, orderRotateRightIcon, orderShuffleAllIcon, orderShuffleByKeyIcon,
    orderClearIcon, orderStickyIcon, settingsIcon, logIcon, plotIcon, effectsIcon, transportOnlyIcon, helpIcon, shareIcon;
    openIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_open.png" ), wxBITMAP_TYPE_PNG );
    saveIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("filesave_gs.png" ), wxBITMAP_TYPE_PNG );
    playIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("player_play.png" ), wxBITMAP_TYPE_PNG );
    pauseIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("media-playback-pause.png" ), wxBITMAP_TYPE_PNG );
    stopIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("player_stop.png" ), wxBITMAP_TYPE_PNG );
    loopIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_repeat.png" ), wxBITMAP_TYPE_PNG );
    playSmashedIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("player_play_inv.png" ), wxBITMAP_TYPE_PNG );
    undoIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("edit-undo_gs.png" ), wxBITMAP_TYPE_PNG );
    redoIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("edit-redo_gs.png" ), wxBITMAP_TYPE_PNG );
    order1ToNIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_draw-line.png" ), wxBITMAP_TYPE_PNG );
    orderNTo1Icon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_draw-line_r.png" ), wxBITMAP_TYPE_PNG );
    orderRotateLeftIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_data-previous.png" ), wxBITMAP_TYPE_PNG );
    orderRotateRightIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_data-next.png" ), wxBITMAP_TYPE_PNG );
    orderShuffleAllIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_shuffle.png" ), wxBITMAP_TYPE_PNG );
    orderShuffleByKeyIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("warp.png"), wxBITMAP_TYPE_PNG );
    orderClearIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("edit-clear-gs.png" ), wxBITMAP_TYPE_PNG );
    orderStickyIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("stock_hyperlink.png" ), wxBITMAP_TYPE_PNG );
    settingsIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("preferences-desktop.png" ), wxBITMAP_TYPE_PNG );
    logIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("logviewer_gs.png" ), wxBITMAP_TYPE_PNG );
    transportOnlyIcon.LoadFile ( appDir + _T ( "png") + wxFileName::GetPathSeparator() + _T("window_nofullscreen_gs.png" ), wxBITMAP_TYPE_PNG );
    helpIcon.LoadFile ( appDir + _T ( "png" ) + wxFileName::GetPathSeparator() + _T("stock_help-agent.png" ), wxBITMAP_TYPE_PNG );
    shareIcon.LoadFile  ( appDir + _T ( "png" ) + wxFileName::GetPathSeparator() + _T("stock_internet_gs.png" ), wxBITMAP_TYPE_PNG );

    toolbar = new wxAuiToolBar ( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxAUI_TB_HORZ_TEXT );
#ifndef __WXMSW__
    volumeSlider = new wxSlider ( toolbar, ID_VOLUME_SLIDER, 10, 0, 10, wxDefaultPosition, wxSize ( 64, 24 ), wxSL_HORIZONTAL );
#else
    volumeSlider = new wxSpinCtrl (
        toolbar, ID_VOLUME_SLIDER, _(""), wxDefaultPosition,
        wxSize ( 48, 20 ), wxSP_ARROW_KEYS | wxSP_VERTICAL, 0, 10, 10, _("volume"));
#endif

    toolbar->SetToolBitmapSize(wxSize(bitmapSize,bitmapSize));
    toolbar->AddTool( ID_OPEN, _(""), openIcon, _("open") );
    toolbar->AddTool( ID_SAVE, _(""), saveIcon, _("save") );
    toolbar->AddTool( wxID_UNDO, _(""), undoIcon, _("undo") );
    toolbar->AddTool( wxID_REDO, _(""), redoIcon, _("redo") );
    toolbar->AddTool( ID_SHARE, _(""), shareIcon, _("share") );
    toolbar->AddSeparator ( );
    toolbar->AddTool( ID_PLAY, _(""), playIcon, _("play original"), wxITEM_CHECK );
    toolbar->AddTool( ID_PLAY_SMASHED, _(""), playSmashedIcon, _("play smashed"), wxITEM_CHECK );
    toolbar->AddTool( ID_PAUSE, _(""), pauseIcon, _("pause"), wxITEM_CHECK );
    toolbar->AddTool( ID_STOP, _(""), stopIcon, _("stop") );
    toolbar->AddTool( ID_LOOP, _(""), loopIcon, _("loop"), wxITEM_CHECK );
    toolbar->AddLabel( wxID_ANY, _("volume"),
#ifdef __WXMSW__
                       32
#else
                       45
#endif
                     );
    toolbar->AddControl( volumeSlider, _("volume") );
    toolbar->AddTool( ID_SHOW_TRANSPORT_ONLY, _(""), transportOnlyIcon, _("transport only"), wxITEM_CHECK );
    toolbar->Realize();

    mapToolbar = new wxAuiToolBar ( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxAUI_TB_HORZ_TEXT );
    sliceNoMemory = 16;
    sliceNoSpinControl = new wxSpinCtrl (
        mapToolbar, ID_SLICE_NO_CHANGE, _(""), wxDefaultPosition, wxSize ( 48, 20 ),
        wxSP_ARROW_KEYS, 1, 32, sliceNoMemory, _("sliceNo"));

    mapToolbar->SetToolBitmapSize(wxSize(bitmapSize,bitmapSize));
    mapToolbar->AddTool( ID_SHOW_SETTINGS, _(""), settingsIcon, _("show/hide controls"), wxITEM_CHECK );
    mapToolbar->AddTool( ID_SHOW_HELP, _(""), helpIcon, _("show/hide help"), wxITEM_CHECK );
#ifdef SMASHER_DEBUG
    mapToolbar->AddTool( ID_SHOW_LOG, _(""), logIcon, _("show/hide log"), wxITEM_CHECK );
#endif
    mapToolbar->AddSeparator();
    mapToolbar->AddLabel( wxID_ANY, _("slices"),
#ifdef __WXMSW__
                          25
#else
                          35
#endif
                        );
    mapToolbar->AddControl( sliceNoSpinControl, _("slices"));
    mapToolbar->AddTool( ID_SLICE_ORDER_1_TO_N, _(""), order1ToNIcon, _("original slice order") );
    mapToolbar->AddTool( ID_SLICE_ORDER_N_TO_1, _(""), orderNTo1Icon, _("invert slice order") );
    mapToolbar->AddTool( ID_SLICE_ORDER_ROTATE_LEFT, _(""), orderRotateLeftIcon, _("rotate left") );
    mapToolbar->AddTool( ID_SLICE_ORDER_ROTATE_RIGHT, _(""), orderRotateRightIcon, _("rotate right") );
    mapToolbar->AddTool( ID_SLICE_ORDER_SHUFFLE_ALL, _(""), orderShuffleAllIcon, _("shuffle slices") );
    mapToolbar->AddTool( ID_SLICE_ORDER_SHUFFLE_BY_KEY, _(""), orderShuffleByKeyIcon, _("warp slices") );
    mapToolbar->AddTool( ID_SLICE_ORDER_CLEAR, _(""), orderClearIcon, _("clear pattern") );
    mapToolbar->AddSeparator();
    mapToolbar->AddTool( ID_FX_ORDER_CLEAR, _(""), orderClearIcon, _("clear effects") );
    mapToolbar->AddTool( ID_FX_ORDER_STICKY, _(""), orderStickyIcon, _("link effects to pattern"), wxITEM_CHECK );
    mapToolbar->Realize();

    size_t sliceNo = sliceNoSpinControl->GetValue();
    size_t cellHeight = 16;
    mapGrid = new MonochromeGrid ( this, wxID_ANY, sliceNo, sliceNo, cellHeight, -1 );
    mapGrid->autoLabel ( );

    std::vector<wxString> vf;

    finishingVector.push_back ( _T ( "master distort" ));
    finishingVector.push_back ( _T ( "master filter" ) );
    finishingVector.push_back ( _T ( "master flanger" ) );
    finishingVector.push_back ( _T ( "master phaser" ) );
    finishingVector.push_back ( _T ( "master reverb" ) );
    finishingVector.push_back ( _T ( "master aux" ) );
    finishingVector.push_back ( _T ( "compress" ) );
    finishingVector.push_back ( _T ( "loudness" ) );
    finishingVector.push_back ( _T ( "enhance" ) );
    finishingVector.push_back ( _T ( "eq" ) );
    finishingVector.push_back ( _T ( "normalize" ) );
    finishingVector.push_back ( _T ( "pitch" ) );
    finishingVector.push_back ( _T ( "match bpm" ) );
    finishingVector.push_back ( _T ( "declick" ) );
    finishingVector.push_back ( _T ( "gate" ) );

    effectsVector.push_back ( _T ("master distort"));
    effectsVector.push_back ( _T ("master filter"));
    effectsVector.push_back ( _T ( "master flanger" ) );
    effectsVector.push_back ( _T ( "master phaser" ) );
    effectsVector.push_back ( _T ("master reverb"));
    effectsVector.push_back ( _T ("master aux"));
    effectsVector.push_back ( _T ("retrigger"));
    effectsVector.push_back ( _T ("reverse"));
    effectsVector.push_back ( _T ("tremolo"));
    effectsVector.push_back ( _T ("tap delay"));
    //effectsVector.push_back ( _("pan delay"));
    effectsVector.push_back ( _T ("lowpass"));
    effectsVector.push_back ( _T ("highpass"));
    effectsVector.push_back ( _T ("bandpass"));
    effectsVector.push_back ( _T ("bandstop"));
    effectsVector.push_back ( _T ("fade in"));
    effectsVector.push_back ( _T ("fade out"));
    effectsVector.push_back ( _T ("tapestop"));
    effectsVector.push_back ( _T ("bitcrush"));
    effectsVector.push_back ( _T ("downsample"));

    effectsGrid = new EffectsGrid ( this, wxID_ANY, effectsVector, sliceNo, cellHeight, -1 );
    progressGrid = new ProgressGrid ( this, wxID_ANY, sliceNo, cellHeight );
    progressGrid->setColumn ( 0 );

#ifdef SMASHER_DEBUG
    logText = new wxTextCtrl( this, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE );
    redirect = new wxStreamToTextRedirector ( logText );
#endif

    mediaCtrl = new wxMediaCtrl ( this, ID_MEDIACTRL
#ifdef __WXMSW__
                                  , wxEmptyString, wxDefaultPosition, wxDefaultSize, 0,
                                  wxMEDIABACKEND_WMP10
#endif
                                );

    mediaTimer = new MediaTimer ( this );
    mediaTimer->SetOwner( this );
    if ( !mediaTimer->Start ( 150 ) )
        std::cout << "can't start timer" << std::endl;

    loopTimer = new LoopTimer ( this, mediaCtrl, mediaCtrlAlt, &loopState );
    loopTimer->SetOwner( this );

    mediaCtrlAlt = new wxMediaCtrl ( this, ID_MEDIACTRL_ALT
#ifdef __WXMSW__
                                     , wxEmptyString, wxDefaultPosition, wxDefaultSize, 0,
                                     wxMEDIABACKEND_WMP10
#endif
                                   );

    mediaTimerAlt = new MediaTimer ( this );
    mediaTimerAlt->SetOwner( this );
    if ( !mediaTimerAlt->Start ( 150 ) )
        std::cout << "can't start timer" << std::endl;

    wxSize plotSize = wxSize ( -1, 75 );
    wxSize previewBoxSize = wxSize ( ( int ) ( 1.1 * plotSize.GetWidth()), -1 );

    lPlot = new WaveWindow ( this, wxID_ANY, wxDefaultPosition, plotSize );
    rPlot = new WaveWindow ( this, wxID_ANY, wxDefaultPosition, plotSize );


    manager = new wxAuiManager ( this );

    wxSize bookSize =
#ifdef __WXMSW__
        wxSize ( ( effectsVector.size() * 17 ) + 10, -1);
#else
        wxSize ( ( effectsVector.size() * 17 ) + 10, -1);
#endif

    settingsBook = new SettingsBook ( this, wxID_ANY, effectsGrid, bookSize.x, finishingVector );
    settingsBook->initPresets();
    helpPane = new wxHtmlWindow ( this, wxID_ANY, wxDefaultPosition, bookSize );

#ifdef __WXMSW__
    wxSize logSize = wxSize( -1, 50 );
    wxSize seqSize = wxSize( -1, cellHeight * ( sliceNo + 1 ) );
    wxSize fxSize = wxSize( -1, ( int ) ( 0.75 * cellHeight * effectsVector.size() ));
    wxSize wavSize = wxSize( -1, 75 );
#else
    wxSize logSize = wxSize( -1, -1 );
    wxSize seqSize = wxSize( -1, -1 );
    wxSize fxSize = wxSize( -1, -1 );
    wxSize wavSize = wxSize( -1, -1 );
#endif

    int dockPropMG, dockPropEG, dockPropPG, dockPropP;
    dockPropMG = 21;
    dockPropEG = 12;
    dockPropPG = 3;
    dockPropP = 6;

    manager->AddPane (
        toolbar, wxAuiPaneInfo().
        Name(wxT("toolbar")).Caption(wxT("toolbar")).
        ToolbarPane().Top().
        Layer(3).
        Row(0).Position(0).
        Floatable ( false ).Gripper ( false ));

    manager->AddPane (
        mapToolbar, wxAuiPaneInfo().
        Name(wxT("mapToolbar")).Caption(wxT("mapToolbar")).
        ToolbarPane().Top().
        Layer(3).
        Row(0).Position(1).
        Floatable ( false ).Gripper ( false ));

    manager->AddPane (
        settingsBook, wxAuiPaneInfo().
        Name(wxT("settingsBook")).Caption( _("controls")).
        Left().
        Layer(2).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( true ).
        //Resizable( true ). //tbd
        Resizable( false ).
        Floatable ( false ).
        MinSize( bookSize ).
        DestroyOnClose ( false ).
        Hide());

    manager->AddPane (
        helpPane,
        wxAuiPaneInfo().
        Name(wxT("helpPane")).Caption( _("help")).
        Right().
        Layer(2).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( true ).
        Resizable( true ).Floatable ( false ).
        DestroyOnClose ( false ).
        Hide() );

    manager->AddPane (
        mapGrid, wxAuiPaneInfo().
        Name(wxT("mapGrid")).Caption(wxT("pattern")).
        Center().
        Layer(0).
        Position(0).
        Row(0).
        CloseButton ( false ).MaximizeButton( true ).MinimizeButton(true).
        Resizable( true ).Floatable ( false ).
        MinSize( seqSize ));
    manager->GetPane ( mapGrid ).dock_proportion = dockPropMG;

    manager->AddPane (
        effectsGrid, wxAuiPaneInfo().
        Name(wxT("effectsGrid")).Caption(wxT("effects")).
        CaptionVisible( false ).
        Center().
        Layer(0).
        Position(1).
        Row(0).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Resizable( true ).Floatable ( false ).
        MinSize( fxSize ).
        Hide());
    manager->GetPane ( effectsGrid ).dock_proportion = dockPropEG;

    manager->AddPane (
        progressGrid, wxAuiPaneInfo().
        Name(wxT("progressGrid")).Caption(wxT("progress")).
        CaptionVisible ( false ).
        Center().
        Layer(0).
        Position(2).
        Row(0).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Resizable( false ).Floatable ( false ).
        MinSize ( wxSize ( -1, 18 ) )
        .Hide()
    );
    manager->GetPane ( progressGrid ).dock_proportion = dockPropPG;

    manager->AddPane (
        lPlot,
        wxAuiPaneInfo().
        Name(wxT("waveformL")).Caption(_("left channel")).
        CaptionVisible( false ).
        Center().
        Layer(0).
        Position(3).
        Row(0).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Resizable ( true ).Floatable ( false ).
        MinSize( wavSize ).
        Hide() );
    manager->GetPane ( lPlot ).dock_proportion = dockPropP;

    manager->AddPane (
        rPlot,
        wxAuiPaneInfo().
        Name(wxT("waveformR")).Caption(_("right channel")).
        CaptionVisible( false ).
        Center().
        Layer(0).
        Position(4).
        Row(0).
        MaximizeButton( false ).MinimizeButton( false ).CloseButton ( false ).
        Floatable ( false ).Resizable ( true ).
        MinSize( wavSize ).
        Hide() );
    manager->GetPane ( rPlot ).dock_proportion = dockPropP;

#ifdef SMASHER_DEBUG
    manager->AddPane (
        logText, wxAuiPaneInfo().Caption( _("log")).
        Name(wxT("logText")).
        Bottom().
        Layer(3).
        MaximizeButton( true ).MinimizeButton( true ).CloseButton ( false ).
        Resizable( true ).Floatable ( false ).
        MinSize( logSize ).
        Hide());
#endif

    manager->AddPane (
        mediaCtrl, wxAuiPaneInfo().Caption( _("media control")).
        Name(wxT("mediaCtrl")).
        Bottom().
        Layer(4).
        MaximizeButton( true ).MinimizeButton( true ).CloseButton ( false ).
        Resizable( true ).Floatable ( false ).
        MinSize( logSize )
        .Hide()
    );

    DoFxOrderSticky();

    bool keepDefaultConfig = false;
    if ( config )
    {
        fileHistory.Load ( *config );
        updateFileMenu();

        bool bVal = false;
        int iVal;
        wxString strVal;

        bool hasEntry;

        hasEntry = config->Read ( _T ("version"), &iVal );
        if ( !hasEntry || iVal < SMASHER_REQUIRED_CONFIG_VERSION )
        {
            SetStatusText ( _T("Configuration file out of date") );
            keepDefaultConfig = true;
        }

#ifdef SMASHER_DEBUG
        hasEntry = config->Read ( _T ("showLogText"), &bVal );
        if ( hasEntry && bVal )
            DoShowLog();
#endif

        hasEntry = config->Read ( _T ("showSettingsBook"), &bVal );
        if ( !hasEntry || bVal )
            DoShowSettings();

        hasEntry = config->Read ( _T ("showTransportOnly"), &bVal);
        if ( hasEntry && bVal )
            DoShowTransportOnly();

        int currentSettingsBookPage, currentTreePage;

        if ( config->Read ( _T("currentSettingsBookPage"), &iVal ))
        {
            currentSettingsBookPage = iVal;
            settingsBook->SetSelection ( currentSettingsBookPage );
            if ( iVal < 2 )
            {
                if ( config->Read ( _T("currentTreeBookPage" ), &iVal ))
                {
                    currentTreePage = iVal;
                    wxTreebook *tree = (wxTreebook *)settingsBook->GetPage ( currentSettingsBookPage );
                    tree->SetSelection ( currentTreePage );
                }
            }
        }

        if ( config->Read ( _T( "stickyFx" ), &bVal  ))
        {
            if ( !bVal )
                DoFxOrderSticky();
        }
        if ( config->Read ( _T( "loop" ), &bVal ))
        {
            if ( bVal )
                DoLoop();
        }

        if ( config->Read ( _T("playbackCompensation"), &iVal ) )
        {
            settingsBook->getPlaybackSlider()->SetValue ( iVal );
        }

        if ( config->Read ( _T("playbackCompensationChecked"), &bVal ) )
        {
            settingsBook->getPlaybackCheckbox()->SetValue ( bVal );
        }

        if ( config->Read ( _T("warpGrid"), &strVal ) )
        {
            settingsBook->getWarpGrid()->loadState( strVal );
        }
        else
        {
            settingsBook->getWarpGrid()->preset( 0 );
        }

        if ( config->Read ( _T("songLength"), &iVal ) )
        {
            settingsBook->getSongLengthSlider()->SetValue ( iVal );
        }

        if ( config->Read ( _T("songShuffleVersesChecked"), &bVal ) )
        {
            settingsBook->getSongShuffleVersesCheckbox()->SetValue ( bVal );
        }

        if ( config->Read ( _T("volume"), &iVal ) )
        {
            volumeSlider->SetValue ( iVal );
            mediaCtrl->SetVolume( iVal * 0.1 );
            mediaCtrlAlt->SetVolume( iVal * 0.1 );
        }


        if ( config->Read ( _T("hideFxRows"), &strVal ) )
        {
            std::string stdVal = ( const char * ) strVal.mb_str ( wxConvUTF8 );
            char delims[] = "|";
            char *temp = strtok ( ( char * ) stdVal.c_str(), delims );
            std::set<wxString> hiddenFxRows;
            while ( temp != NULL )
            {
                std::string currentLabel = temp;
                hiddenFxRows.insert ( wxString ( currentLabel.c_str(), wxConvUTF8, currentLabel.size() ) );
                temp = strtok ( NULL, delims );
            }
            int limit = ID_EFFECTS_START + effectsGrid->GetNumberRows();
            for ( int i = ID_EFFECTS_START; i < limit; i++ )
            {
                wxToggleButton *currentToggleButton = ( wxToggleButton* ) FindWindowById ( i, settingsBook );
                currentToggleButton->SetValue ( !hiddenFxRows.count ( currentToggleButton->GetLabel() ) );
            }
            settingsBook->updateShowFxRows();
        }

        if ( config->Read (_T("factoryListView"), &strVal ) )
        {
            int itemCount = settingsBook->getFactoryListView()->GetItemCount();
            wxString currentItemtext;
            for ( int i = 0; i < itemCount; i++ )
            {
                currentItemtext = settingsBook->getFactoryListView()->GetItemText ( i );
                if ( currentItemtext == strVal )
                {
                    settingsBook->getFactoryListView()->Select( i );
                    activateFactoryPreset( i );
                    presetLoaded = true;
                    break;
                }
            }
        }

        if ( config->Read (_T("sharePreset"), &strVal ) )
            sharePreset = strVal;
        if ( config->Read (_T("shareAuthor"), &strVal ) )
            shareAuthor = strVal;
        if ( config->Read (_T("sharePasscode"), &strVal ) )
            sharePasscode = strVal;
        if ( config->Read (_T("shareEmail"), &strVal ) )
            shareEmail = strVal;
        if ( config->Read (_T("communityPresets"), &strVal ) )
            settingsBook->refreshPresets ( strVal );

        wxString state = config->Read ( _T ("state"), wxEmptyString );
        if ( !state.empty() )
            loadState ( state );
    }
    else // !config
    {
        settingsBook->initControls();
    }

    if ( keepDefaultConfig || !presetLoaded )
        activateFactoryPreset ( 0 );

    wxString defaultState = saveState();
    loadState ( defaultState );

    DoShowEffects();
    DoShowProgressGrid();
    DoShowPlot();

    stateMemory = saveState();
    history.initialize ( stateMemory );

    if ( viewSettingsState )
        settingsBook->initPlotAreas();

    progressGrid->reset();

    loopLatency = ( settingsBook->getPlaybackCheckbox()->IsChecked() ) ? settingsBook->getPlaybackSlider()->GetValue() : 0;

    try
    {
        w = new Wav16Smash( &threadAbort, &smashMessage );
        pathValid =  DoOpen ( w, fileIn );
        if ( pathValid )
        {
            updateTitle ( fileIn );
        }

    }
    catch (std::exception &e)
    {
        std::cout << "smasherFrame c'tor: " << e.what() << std::endl;
    }

    manager->Update();

    timer = new wxTimer ( this, ID_TIMER );
    timer->Start( 100 );
}

smasherFrame::~smasherFrame()
{
    DoStop();
    closeDown = true;
    mediaTimer->Stop();
    mediaTimerAlt->Stop();
    loopTimer->Stop();
    timer->Stop();

    waitForThreadsToFinish();

    if ( config )
    {
        config->Write ( _T("version"), SMASHER_VERSION );
#ifdef SMASHER_DEBUG
        config->Write ( _T("showLogText"), viewMenu->IsChecked ( ID_SHOW_LOG ) );
#endif
        config->Write ( _T("showSettingsBook"), viewMenu->IsChecked ( ID_SHOW_SETTINGS ) );
        config->Write ( _T("showTransportOnly"), viewMenu->IsChecked ( ID_SHOW_TRANSPORT_ONLY ) );

        int settingsBookSelection = settingsBook->GetSelection();
        int settingsTreeSelection = -1;
        if ( settingsBookSelection < 2 )
        {
            wxTreebook *bookSelection = ( wxTreebook *) ( settingsBook->GetPage( settingsBookSelection ));
            settingsTreeSelection = bookSelection->GetSelection();
        }
        config->Write ( _T( "currentSettingsBookPage" ), settingsBookSelection );
        config->Write ( _T( "currentTreeBookPage" ), settingsTreeSelection );
        config->Write ( _T( "playbackCompensation" ), settingsBook->getPlaybackSlider()->GetValue() );
        config->Write ( _T( "playbackCompensationChecked" ), settingsBook->getPlaybackCheckbox()->IsChecked() );
        config->Write ( _T( "volume" ), volumeSlider->GetValue() );
        config->Write ( _T( "warpGrid" ), settingsBook->getWarpGrid()->saveState() );
        config->Write ( _T( "songLength" ), settingsBook->getSongLengthSlider()->GetValue() );
        config->Write ( _T( "songShuffleVersesChecked" ), settingsBook->getSongShuffleVersesCheckbox()->IsChecked() );

        config->Write ( _T( "stickyFx" ), mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) );
        config->Write ( _T( "loop" ), toolbar->GetToolToggled ( ID_LOOP ) );
        config->Write ( _T( "sharePreset" ), sharePreset);
        config->Write ( _T( "shareAuthor" ), shareAuthor);
        config->Write ( _T( "sharePasscode" ), sharePasscode);
        config->Write ( _T( "shareEmail" ), shareEmail);
        config->Write ( _T( "communityPresets" ), settingsBook->getCommunityPresets() );

        wxString hideFxRowsState;
        int limit = ID_EFFECTS_START + effectsGrid->GetNumberRows();
        for ( int i = ID_EFFECTS_START; i < limit; i++ )
        {
            wxToggleButton *currentToggleButton = ( wxToggleButton* ) FindWindowById ( i, settingsBook );
            if ( !currentToggleButton->GetValue() )
            {
                hideFxRowsState += currentToggleButton->GetLabel();
                hideFxRowsState += _T("|");
            }
        }
        config->Write ( _T( "hideFxRows" ), hideFxRowsState );
        int index = settingsBook->getFactoryListView()->GetFirstSelected();
        config->Write ( _T("factoryListView"),
                        settingsBook->getFactoryListView()->GetItemText( index ) );

        config->Write ( _T( "state" ), saveState() );
        fileHistory.Save ( *config );
    }

    delete config;
    delete redirect;
    //delete defaultStates; //tbr
    delete mediaCtrl;
    delete mediaCtrlAlt;
    delete mediaTimer;
    delete mediaTimerAlt;
    delete loopTimer;
    delete timer;
}

void smasherFrame::smashSync ( Wav16Smash *wav )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( !pathValid )
        return;

    try
    {
        int wav16State = wav->getState();
        if ( wav16State == WAV16_INIT || wav16State == WAV16_ERROR )
        {
            std::cout << "smashSync: wav16State == WAV16_INIT || wav16State == WAV16_ERROR" << std::endl;
            smashRequired = false;
            return;
        }

        wav->clearSliceInfo();
        std::vector<size_t> posVector;
        mapGrid->getPositionVector( posVector );
        SmashGridMapper<std::vector<double> > sgm ( posVector );
        wav->setSmashMapper ( &sgm );
        addTransformers( wav, posVector );

        if ( !wav->smash( mapGrid->GetNumberCols() ))
        {
            wxString wideMessage = wxString ( smashMessage.c_str(), wxConvUTF8, smashMessage.size() );
            SetStatusText ( wideMessage );
            return;
        }
    }
    catch (std::exception &e)
    {
        std::cout << "smashSync: " << e.what() << std::endl;
    }
}

void smasherFrame::smashAsync ()
{

    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    try
    {
        int wav16State = w->getState();
        if ( wav16State == WAV16_INIT || wav16State == WAV16_ERROR )
        {
            std::cout << "smashAsync: wav16State == WAV16_INIT || wav16State == WAV16_ERROR" << std::endl;
            smashRequired = false;
            return;
        }

        if ( !smashRequired )
        {
            return;
        }

        if ( getCurrentMediaCtrl()->GetState() == wxMEDIASTATE_PLAYING )
            changedWhilePlaying = true;

        w->clearSliceInfo();
        std::vector<size_t> posVector;
        mapGrid->getPositionVector( posVector );

        SmashGridMapper<std::vector<double> > *sgm =
            new SmashGridMapper<std::vector<double> > ( posVector );

        w->setSmashMapper ( sgm );

        addTransformers( w, posVector );

        thread = new SmashThread (
            w,
            &threadState,
            &smashMessage,
            mapGrid->GetNumberCols() );

        if ( thread->Create() != wxTHREAD_NO_ERROR )
        {
            threadState = SMASH_THREAD_INIT;
            throw std::runtime_error ( "smasherFrame::smashAsync() - thread->Create() unsuccessful" );
            return;
        }

        threadState = SMASH_THREAD_RUNNING;
        smashRequired = false;
        threadAbort = false;

        thread->Run();
    }
    catch (std::exception &e)
    {
        std::cout << "smashAsync: " << e.what() << std::endl;
    }

}

void smasherFrame::DoClearOrder( MonochromeGrid *m )
{
    m->clearAll();
}

void smasherFrame::DoFxOrderShuffleAll ( )
{
    effectsGrid->clearAll();
    std::vector<size_t> positionVector;
    std::vector<wxString> shuffledEffectsVector;

    size_t effectsCount = effectsVector.size();
    size_t sliceNo = effectsGrid->GetNumberCols();
    size_t randomEffectsCount = 2 * effectsCount / sliceNo;

    for ( size_t i = 0; i < effectsCount; i++ )
        shuffledEffectsVector.push_back ( effectsVector.at ( i ) );

    std::random_shuffle ( shuffledEffectsVector.begin(), shuffledEffectsVector.end() );

    for ( size_t i = 0; i < effectsCount; i += randomEffectsCount )
    {
        effectsGrid->createRandomPositionVector ( positionVector,  ( 1 > sliceNo / effectsCount ) ? 1 : sliceNo / effectsCount );
        effectsGrid->setNamedPositionVector ( shuffledEffectsVector.at( i ), positionVector );
    }

}

void smasherFrame::DoFxOrderShuffleByKey (  )
{
    std::string key;

    settingsBook->getWarpGrid()->getWarpKey ( key );

    if ( key.empty() )
        return;

    std::vector<wxString>::iterator it;
    std::vector<size_t> positionVector;
    std::vector<bool> binaryPositionVector;
    for ( it = effectsVector.begin(); it != effectsVector.end(); it++ )
    {
        positionVector.clear ();
        binaryPositionVector.clear();
        effectsGrid->getNamedPositionVector( *it, positionVector );
        int colNo = effectsGrid->GetNumberCols();
        bool found = false;
        for ( size_t i = 0; i < (size_t)colNo; i++ )
        {
            found = false;
            for ( size_t j = 0; j < positionVector.size(); j++ )
            {
                if ( i == positionVector.at ( j ) )
                {
                    found = true;
                    break;
                }
            }
            binaryPositionVector.push_back ( found );
        }
        KeyMapper<char, bool> *km = new KeyMapper<char, bool>( key, binaryPositionVector );
        //km->map( binaryPositionVector );
        km->unMap( binaryPositionVector );
        positionVector.clear();
        for ( size_t i = 0; i < binaryPositionVector.size(); i++ )
        {
            if ( binaryPositionVector.at ( i ) )
                positionVector.push_back ( i );
        }
        effectsGrid->setNamedPositionVector ( *it, positionVector );
    }
}

void smasherFrame::DoFxOrderSticky()
{
    orderStickyState = !orderStickyState;

    mapToolbar->EnableTool ( ID_FX_ORDER_CLEAR, !orderStickyState );
    mapToolbar->ToggleTool ( ID_FX_ORDER_STICKY, orderStickyState );
    mapToolbar->Realize();
    manager->Update ();
}


void smasherFrame::DoIdle()
{
    int sliceNo = sliceNoSpinControl->GetValue( );
    if ( sliceNo != sliceNoMemory
            && sliceNo != mapGrid->GetNumberCols() )
    {
        DoSliceNoChange();
    }

    if ( !pathValid )
        return;

    if ( wxGetMouseState().LeftDown() )
        return;

    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( threadState == SMASH_THREAD_FINISHED )
    {
        wxString wideMessage = wxString ( smashMessage.c_str(), wxConvUTF8, smashMessage.size() );
        SetStatusText ( wideMessage );

        updatePlotArea();

        threadState = SMASH_THREAD_INIT;
        smashMessage.clear();

        return;
    }

    wxString state = saveState();

    if ( ( state == stateMemory ) && !smashRequired )
        return;

    SetStatusText ( wxEmptyString );

    history.pushState ( state );
    stateMemory = state;
    smashRequired = true;

    if ( threadState == SMASH_THREAD_RUNNING )
    {
        threadAbort = true;
        return;
    }

    smashAsync();

}

void smasherFrame::DoLoop ()
{
    loopState = !loopState;
    toolbar->ToggleTool (ID_LOOP, loopState);
    toolbar->Realize();
    transportMenu->Check (ID_LOOP, loopState);
}

void smasherFrame::DoPause()
{
    pauseState = !pauseState;
    toolbar->ToggleTool ( ID_PAUSE, pauseState );
    toolbar->Realize();
    transportMenu->Check (ID_PAUSE, pauseState );

    if ( pauseState && getCurrentMediaCtrl()->GetState() == wxMEDIASTATE_PLAYING )
    {
        getCurrentMediaCtrl()->Pause();
        loopTimer->Stop();
    }
    else if ( !pauseState && getCurrentMediaCtrl()->GetState() == wxMEDIASTATE_PAUSED )
    {
        getCurrentMediaCtrl()->Play();
        wxLongLong llTell = getCurrentMediaCtrl()->Tell();
        wxLongLong llLength = getCurrentMediaCtrl()->Length();
        loopTimer->Start ( (int) ( llLength.GetValue() - llTell.GetValue() ) - loopLatency, true );
    }
}

void smasherFrame::waitForThreadsToFinish ()
{
    size_t timeout = 10;
    while ( timeout )
    {
        {
            smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );
            if ( threadState != SMASH_THREAD_RUNNING )
                return;
        }
        ::wxMilliSleep ( 1000 );
        timeout--;
    }
    SetStatusText ( _("timed out") );
}

void smasherFrame::DoMediaFinished()
{}

void smasherFrame::DoMediaLoaded()
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( !getCurrentMediaCtrl()->Play() )
    {
        std::cout << "DoMediaLoaded: !mediaCtrl->Play() - ID = " << getCurrentMediaCtrl()->GetId() << std::endl;
        return;
    }
    startLoopTimer();
}


bool smasherFrame::DoOpen( Wav16Smash *wav, const wxString& wideFile )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    waitForThreadsToFinish ();

    for ( int i = 0; i < STATUS_END; i++ )
        SetStatusText ( wxEmptyString, i );

    if ( !wxFileName::FileExists ( wideFile ) )
    {
        wxString message = wideFile;
        message += _( " doesn't exist" );
        SetStatusText ( message );
        return false;
    }

    wxString testName = wideFile;
    if ( testName.MakeLower().Contains ( _T(".smash") ) )
    {
        SetStatusText ( _("not a sample") );
        return false;
    }

    try
    {
        wav->clear();

        std::string file = (const char *) wideFile.mb_str( wxConvUTF8);
        handleMp3 ( file );
        if ( !wav->read ( ( char * ) file.c_str() ) )
        {
            SetStatusText ( _T ("can't read ") + wideFile );
            return false;
        }

        smashSync( wav );

    }
    catch (std::exception &e)
    {
        std::cout << "DoOpen: " << e.what() << std::endl;
        return false;
    }

    wxString channelsInfo, samplerateInfo;
    channelsInfo = ( wav->getChannels() == 2 ) ? _("stereo") : _("mono");
    samplerateInfo.Printf ( _("%i Hz"), wav->getSamplerate() );

    if ( GetStatusBar()->GetStatusText ( STATUS_CHANNELS ) != channelsInfo )
        GetStatusBar()->SetStatusText ( channelsInfo, STATUS_CHANNELS );

    if ( GetStatusBar()->GetStatusText ( STATUS_SAMPLERATE ) != samplerateInfo )
        GetStatusBar()->SetStatusText ( samplerateInfo, STATUS_SAMPLERATE );

    wxString state = saveState();
    history.initialize( state );
    stateMemory = state;

    fileHistory.AddFileToHistory ( wideFile );
    updateFileMenu();

    updatePlotArea();
    return true;
}


bool smasherFrame::DoPlaySmashed ( int requestedSlice )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    waitForThreadsToFinish();

    try {
        wxString tmpState = saveState();

        if ( smashedFileMap.count( tmpState ) )
        {
            if ( !play ( smashedFileMap[tmpState] ))
            {
                std::cout << "DoPlaySmashed: !play ( smashedFileMap[tmpState], loopIsToggled )" << std::endl;
                throw std::runtime_error ( "play() failed" );
            }
            return true;
        }
        if ( w->getState() == WAV16_HAS_DATA_IN )
        {
            smashSync( w );
            updatePlotArea();
        }

        if ( w->getState() != WAV16_HAS_DATA_OUT )
        {
            std::cout << "DoPlaySmashed: w->getState() != WAV16_HAS_DATA_OUT" << std::endl;
            return false;
        }

        std::string fileOut;
        wxString wideFileOut;

        WrapTempFileName wtfn;
        wtfn.setKeepFiles ( true );
        fileOut = wtfn.name();
        wideFileOut = wtfn.wideName();

        wideFileOut += _T(".wav");
        fileOut += ".wav";

        tempFiles.push_back ( wideFileOut );

        if ( !w->write ( ( char * ) fileOut.c_str() ))
        {
            std::cout << "DoPlaySmashed: !w->write" << std::endl;
            throw std::runtime_error ( "write() failed" );
        }

        if ( !play ( wideFileOut /*, loopIsToggled */ ))
        {
            std::cout << "DoPlaySmashed: !play ( wideFileOut, loopIsToggled ) )" << std::endl;
            throw std::runtime_error ( "play() failed" );
        }

        smashedFileMap.insert ( std::make_pair ( tmpState, wideFileOut ));
        return true;
    }
    catch (std::exception &e)
    {
        std::cout << "DoPlaySmashed: " << e.what() << std::endl;
        return false;
    }
}

void smasherFrame::DoShowEffects ( )
{
    viewEffectsState =  !viewEffectsState;
    mapToolbar->ToggleTool (ID_SHOW_EFFECTS, viewEffectsState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_EFFECTS, viewEffectsState );

    manager->GetPane ( effectsGrid ).Show( viewEffectsState );
    manager->Update ();
}

void smasherFrame::DoShowHelp()
{
    viewHelpState = !viewHelpState;
    mapToolbar->ToggleTool ( ID_SHOW_HELP, viewHelpState );
    mapToolbar->Realize();
    helpMenu->Check ( ID_SHOW_HELP, viewHelpState );

    if ( viewHelpState && !helpPageLoaded )
    {
        initHelpPane();
        manager->GetPane ( helpPane );
    }

    manager->GetPane ( helpPane ).Show ( viewHelpState );
    manager->Update();
}

void smasherFrame::DoShowProgressGrid()
{
    manager->GetPane ( progressGrid ).Show ( true );
    manager->Update();
}

void smasherFrame::DoShowLog ()
{
#ifdef SMASHER_DEBUG
    viewLogState =  !viewLogState;
    mapToolbar->ToggleTool (ID_SHOW_LOG, viewLogState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_LOG, viewLogState );
    manager->GetPane ( logText ).Show( viewLogState );
    manager->Update ();
#endif
}

void smasherFrame::DoShowPlot ()
{
    viewPlotState =  !viewPlotState;
    mapToolbar->ToggleTool (ID_SHOW_PLOT, viewPlotState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_PLOT, viewPlotState );
    manager->GetPane ( lPlot ).Show ( viewPlotState );
    manager->GetPane ( rPlot ).Show ( viewPlotState );
    manager->Update ();
}

void smasherFrame::DoShowSettings ()
{
    viewSettingsState =  !viewSettingsState;
    mapToolbar->ToggleTool (ID_SHOW_SETTINGS, viewSettingsState );
    mapToolbar->Realize();
    viewMenu->Check (ID_SHOW_SETTINGS, viewSettingsState );
    manager->GetPane ( settingsBook ).Show( viewSettingsState );
    manager->Update ();
}

void smasherFrame::DoShowTransportOnly ()
{
    viewTransportOnlyState =  !viewTransportOnlyState;
    if ( viewTransportOnlyState )
    {
        perspectiveMemory = manager->SavePerspective();
        sizeMemory = GetSize();
    }
    else if ( !perspectiveMemory.empty() )
    {
        manager->LoadPerspective( perspectiveMemory );
        SetSize ( sizeMemory );
        toolbar->ToggleTool (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
        toolbar->Realize();
        viewMenu->Check (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
        manager->Update();
        return;
    }
    toolbar->ToggleTool (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
    toolbar->Realize();
    viewMenu->Check (ID_SHOW_TRANSPORT_ONLY, viewTransportOnlyState );
    manager->GetPane ( mapToolbar ).Show( !viewTransportOnlyState );
#ifdef SMASHER_DEBUG
    manager->GetPane ( logText ).Show( !viewTransportOnlyState );
#endif
    manager->GetPane ( settingsBook ).Show( !viewTransportOnlyState );
    manager->GetPane ( effectsGrid ).Show( !viewTransportOnlyState );
    manager->GetPane ( mapGrid ).Show( !viewTransportOnlyState );
    manager->GetPane ( lPlot ).Show( !viewTransportOnlyState );
    manager->GetPane ( rPlot ).Show( !viewTransportOnlyState );
    manager->GetPane ( helpPane ).Show( !viewTransportOnlyState );
    manager->GetPane ( progressGrid ).Show( !viewTransportOnlyState );
    manager->Update ();
    Fit();
}

void smasherFrame::DoSliceNoChange ()
{
    int sliceNo = sliceNoSpinControl->GetValue( );
    if ( sliceNo != mapGrid->GetNumberCols() )
    {
        mapToolbar->Realize();

        mapGrid->resizeCols ( sliceNo );
        mapGrid->resizeRows ( sliceNo );
        mapGrid->autoLabel ( );
        effectsGrid->resizeCols ( sliceNo );
        progressGrid->resizeCols ( sliceNo );
        progressGrid->reset();

        sliceNoMemory = sliceNo;
    }
}

void smasherFrame::DoSliceOrder1ToN ( MonochromeGrid *m )
{
    std::vector<size_t> positionVector;
    size_t colNo = (size_t) m->GetNumberCols();
    for ( size_t i = 0; i < colNo; i++)
        positionVector.push_back ( i );

    m->setPositionVector ( positionVector );
}

void smasherFrame::DoSliceOrderNTo1 ( MonochromeGrid *m )
{
    std::vector<size_t> positionVector;
    size_t colNo = (size_t) m->GetNumberCols();
    for ( size_t i = 0; i < colNo; i++)
        positionVector.push_back ( colNo - i - 1 );

    m->setPositionVector ( positionVector );
}

void smasherFrame::DoSliceOrderShuffleAll ( MonochromeGrid *m )
{
    std::vector<size_t> positionVector;
    size_t colNo = (size_t) m->GetNumberCols();
    for ( size_t i = 0; i < colNo; i++)
        positionVector.push_back ( i );

    std::random_shuffle ( positionVector.begin(), positionVector.end() );
    m->setPositionVector ( positionVector );

    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        DoFxOrderShuffleAll();
}

void smasherFrame::DoSliceOrderShuffleByKey ( MonochromeGrid *m )
{
    std::string key;

    settingsBook->getWarpGrid()->getWarpKey ( key );

    if ( key.empty() )
        return;

    std::vector<size_t> positionVector;
    m->getPositionVector( positionVector );
    KeyMapper<char, size_t> *km = new KeyMapper<char, size_t>( key, positionVector );

    km->unMap( positionVector );

    m->setPositionVector ( positionVector );

    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        DoFxOrderShuffleByKey();
}


void smasherFrame::DoStop ()
{
    getCurrentMediaCtrl()->Pause();
    getCurrentMediaCtrl()->Stop();
    getAlternativeMediaCtrl()->Pause();
    getAlternativeMediaCtrl()->Stop();
    loopTimer->Stop();
    if ( pauseState )
        DoPause();

    //wxSound::Stop();
}

void smasherFrame::DoVolumeChanged( )
{
    int selectedVolume = volumeSlider->GetValue();
    getCurrentMediaCtrl()->SetVolume( selectedVolume * 0.1 );
    getAlternativeMediaCtrl()->SetVolume( selectedVolume * 0.1 );
}

void smasherFrame::handleMp3 ( std::string& file )
{
    if ( file.find(".mp3") == std::string::npos )
        return;

    wxString wideFile, wideFileOut;

    wideFile = wxString ( file.c_str(), wxConvUTF8, file.size() );
    std::string fileOut;
    WrapTempFileName wtfn;
    wtfn.setKeepFiles ( true );
    fileOut = wtfn.name();
    wideFileOut = wtfn.wideName();
    tempFiles.push_back ( wideFileOut );

#ifdef __WXMSW__
    wxString cmd = _T("\"");
    cmd += appDir;
    cmd += _T("bin");
    cmd += wxFileName::GetPathSeparator();
    cmd += _T("madplay.exe\" -o wave:");

    cmd += wideFileOut;
    cmd += _T(" ");
    cmd += _T("\"");
    cmd += wideFile;
    cmd += _T("\"");

    wxArrayString output;
    wxArrayString errors;
    if ( wxExecute ( cmd, output, errors, wxEXEC_SYNC ))
    {
        SetStatusText ( _T ( "mp3 to wav conversion failed" ) );
        return;
    }

    file =  (const char *) wideFileOut.mb_str( wxConvUTF8);
#else
    WrapLibMad wlm;
    if ( !wlm.mp3ToWav ( file, fileOut ) )
    {
        SetStatusText ( _T ( "mp3 to wav conversion failed" ) );
        return;
    }
    file = fileOut;
#endif
}

void smasherFrame::initHelpPane()
{
    if ( helpPageLoaded )
        return;

    wxString helpFile = appDir + _T("help") + wxFileName::GetPathSeparator() + _T( "index.html" );
    if ( !wxFileName::FileExists ( helpFile ) )
        return;

    helpPane->LoadPage ( helpFile );
    helpPageLoaded = true;
}

void smasherFrame::loadState ( const wxString& state, bool newData )
{
    if ( state.empty() )
        return;

    std::string stdState = (const char*) state.mb_str(wxConvUTF8);
    char delims[] = "|=";
    char * temp = strtok ( (char *) stdState.c_str(), delims );
    std::vector<std::string> v;
    while (temp != NULL)
    {
        v.push_back( temp );
        temp = strtok (NULL, delims);
    }
    std::map<wxString, wxString> m;
    if ( v.size() % 2 )
        return;

    std::string key, value;
    for ( size_t i = 0; i < v.size(); i +=2)
    {
        key = v.at ( i );
        value = v.at ( i + 1 );
        m.insert (
            std::make_pair (
                wxString ( key.c_str(), wxConvUTF8, key.size() ),
                wxString ( value.c_str(), wxConvUTF8, value.size() )));
    }

    mapGrid->clearAll();
    effectsGrid->clearAll();

    fileIn = m [ _T("fileIn") ];
    wxFileName fn ( fileIn );
    if ( !fn.IsAbsolute() )
        fileIn = Dir::getSamplesDir() + fileIn;

    updateTitle ( fileIn );

    long iValue = 8;

    if ( m.count ( _T("sliceNo") ) )
        m [ _T("sliceNo") ].ToLong ( &iValue );

    sliceNoSpinControl->SetValue ( iValue );
    mapGrid->resizeCols ( iValue );
    mapGrid->resizeRows ( iValue );
    effectsGrid->resizeCols ( iValue );
    progressGrid->resizeCols ( iValue );
    mapGrid->loadState( m [ _T("mapGrid") ] );
    mapGrid->autoLabel();

    wxString name, posVectorString;
    std::vector<size_t> positionVector;
    size_t posVectorStringSize;
    size_t effectsVectorSize = effectsVector.size();
    wxString letter;
    for ( size_t i = 0; i < effectsVectorSize; i++ )
    {
        name = effectsVector.at ( i );

        if ( m.count( name ) )
        {
            posVectorString = m [ name ];
            posVectorStringSize = posVectorString.size();
            for ( size_t j = 0; j < posVectorStringSize; j++)
            {
                letter = posVectorString.substr ( j, 1 );
                if ( letter == _T ( "1" ) )
                    positionVector.push_back ( j );
            }
            effectsGrid->setNamedPositionVector ( name, positionVector );
            positionVector.clear();
        }
    }

    settingsBook->initControls();

    if ( m.count(_T("effectsChainBox")) )
    {
        settingsBook->getEffectsChainBox()->loadState( m [ _T("effectsChainBox") ] );
    }

    if ( m.count(_T("finishingChainBox")) )
    {
        settingsBook->getFinishingChainBox()->loadState( m [ _T("finishingChainBox") ] );
    }

    if ( m.count(_T("fadeInType")))
    {
        m [ _T("fadeInType") ] .ToLong ( &iValue );
        settingsBook->getFadeInTypesBox()->SetSelection( iValue );
    }

    if ( m.count ( _T("fadeOutType") ) )
    {
        m [ _T("fadeOutType") ].ToLong ( &iValue );
        settingsBook->getFadeOutTypesBox()->SetSelection( iValue );
    }

    if ( m.count ( _T("tremoloType")  ) )
    {
        m [ _T("tremoloType") ].ToLong ( &iValue );
        settingsBook->getTremoloTypesBox()->SetSelection( iValue );
    }

    if ( m.count(_T("tremoloStereoMode")) )
    {
        m [ _T("tremoloStereoMode") ].ToLong ( &iValue );
        settingsBook->getTremoloStereoModeBox()->SetSelection( iValue );
    }

    if ( m.count ( _T("bitCrushType") ) )
    {
        m [ _T("bitCrushType") ].ToLong ( &iValue );
        settingsBook->getBitCrushTypesBox()->SetSelection( iValue );
    }

    if ( m.count ( _T("downSampleType") ) )
    {
        m [ _T("downSampleType") ].ToLong ( &iValue );
        settingsBook->getDownSampleTypesBox()->SetSelection( iValue );
    }

    if ( m.count ( _T("tremoloDepth") ) )
    {
        m [ _T("tremoloDepth") ].ToLong ( &iValue );
        settingsBook->getTremoloDepthSlider()->SetValue( iValue );
    }

    if ( m.count ( _T("tremoloPeriodsPerSlice") ) )
    {
        m [ _T("tremoloPeriodsPerSlice") ].ToLong ( &iValue );
        settingsBook->getTremoloPeriodsPerSliceSlider()->SetValue( iValue );
    }

    if ( m.count ( _T("masterDistortPregain") ) )
    {
        m [ _T("masterDistortPregain") ].ToLong ( &iValue );
        settingsBook->getDistortPregainSlider()->SetValue( iValue );
    }

    if ( m.count ( _T("masterDistortPostgain") ) )
    {
        m [ _T("masterDistortPostgain") ].ToLong ( &iValue );
        settingsBook->getDistortPostgainSlider()->SetValue( iValue );
    }

    if ( m.count ( _T("masterDistortCutoff") ) )
    {
        m [ _T("masterDistortCutoff") ].ToLong ( &iValue );
        settingsBook->getDistortCutoffSlider()->SetValue( iValue );
    }

    if ( m.count(_T("distortFeedback")) )
    {
        m [ _T("distortFeedback") ].ToLong ( &iValue );
        settingsBook->getDistortFeedbackSlider()->SetValue( iValue );
    }
    if ( m.count(_T("distortToneShaping1")) )
    {
        m [ _T("distortToneShaping1") ].ToLong ( &iValue );
        settingsBook->getDistortToneShaping1Slider()->SetValue( iValue );
    }
    if ( m.count(_T("distortToneShaping2")) )
    {
        m [ _T("distortToneShaping2") ].ToLong ( &iValue );
        settingsBook->getDistortToneShaping2Slider()->SetValue( iValue );
    }

    if ( m.count ( _T("masterDistortCheckbox") ) )
    {
        m [ _T("masterDistortCheckbox") ].ToLong ( &iValue );
        settingsBook->getDistortCheckbox()->SetValue( iValue );
    }

    if ( m.count ( _T("fadeOutRange") ) )
    {
        m [ _T("fadeOutRange") ].ToLong ( &iValue );
        settingsBook->getFadeOutRangeSlider()->SetValue( iValue );
    }

    if ( m.count ( _T("fadeInRange") ) )
    {
        m [ _T("fadeInRange") ].ToLong ( &iValue );
        settingsBook->getFadeInRangeSlider()->SetValue( iValue );
    }

    if ( m.count ( _T("pitchSemitones") ) )
    {
        m [ _T("pitchSemitones") ].ToLong ( &iValue );
        settingsBook->getPitchSemitonesSlider()->SetValue( iValue );
    }

    if ( m.count(_T("pitchAdjust")) )
    {
        m [ _T("pitchAdjust") ].ToLong ( &iValue );
        settingsBook->getPitchAdjustCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("normalizeTo")) )
    {
        m [ _T("normalizeTo") ].ToLong ( &iValue );
        settingsBook->getNormalizeSlider()->SetValue( iValue );
    }

    if ( m.count(_T("normalize")) )
    {
        m [ _T("normalize") ].ToLong ( &iValue );
        settingsBook->getNormalizeCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("compressCutoff")) )
    {
        m [ _T("compressCutoff") ].ToLong ( &iValue );
        settingsBook->getCompressCutoffSlider()->SetValue( iValue );
    }

    if ( m.count(_T("compressRange")) )
    {
        m [ _T("compressRange") ].ToLong ( &iValue );
        settingsBook->getCompressRangeSlider()->SetValue( iValue );
    }

    if ( m.count(_T("compress")) )
    {
        m [ _T("compress") ].ToLong ( &iValue );
        settingsBook->getCompressCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("gate")) )
    {
        m [ _T("gate") ].ToLong ( &iValue );
        settingsBook->getGateCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("LPBandHi")) )
    {
        m [ _T("LPBandHi") ].ToLong ( &iValue );
        settingsBook->getFftLowPassBandHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("LPSlopeHi")) )
    {
        m [ _T("LPSlopeHi") ].ToLong ( &iValue );
        settingsBook->getFftLowPassSlopeHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("HPBandLo")) )
    {
        m [ _T("HPBandLo") ].ToLong ( &iValue );
        settingsBook->getFftHighPassBandLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("HPSlopeLo")) )
    {
        m [ _T("HPSlopeLo") ].ToLong ( &iValue );
        settingsBook->getFftHighPassSlopeLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BPBandLo")) )
    {
        m [ _T("BPBandLo") ].ToLong ( &iValue );
        settingsBook->getFftBandPassBandLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BPSlopeLo")) )
    {
        m [ _T("BPSlopeLo") ].ToLong ( &iValue );
        settingsBook->getFftBandPassSlopeLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BPBandHi")) )
    {
        m [ _T("BPBandHi") ].ToLong ( &iValue );
        settingsBook->getFftBandPassBandHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BPSlopeHi")) )
    {
        m [ _T("BPSlopeHi") ].ToLong ( &iValue );
        settingsBook->getFftBandPassSlopeHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BSBandLo")) )
    {
        m [ _T("BSBandLo") ].ToLong ( &iValue );
        settingsBook->getFftBandStopBandLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BSSlopeLo")) )
    {
        m [ _T("BSSlopeLo") ].ToLong ( &iValue );
        settingsBook->getFftBandStopSlopeLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BSBandHi")) )
    {
        m [ _T("BSBandHi") ].ToLong ( &iValue );
        settingsBook->getFftBandStopBandHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("BSSlopeHi")) )
    {
        m [ _T("BSSlopeHi") ].ToLong ( &iValue );
        settingsBook->getFftBandStopSlopeHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("LoudBandLo")) )
    {
        m [ _T("LoudBandLo") ].ToLong ( &iValue );
        settingsBook->getLoudnessBandLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("LoudBandHi")) )
    {
        m [ _T("LoudBandHi") ].ToLong ( &iValue );
        settingsBook->getLoudnessBandHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("LoudSlopeHi")) )
    {
        m [ _T("LoudSlopeHi") ].ToLong ( &iValue );
        settingsBook->getLoudnessSlopeHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("LoudCheckbox")) )
    {
        m [ _T("LoudCheckbox") ].ToLong ( &iValue );
        settingsBook->getLoudnessCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterTypesBox")) )
    {
        m [ _T("MasterFilterTypesBox") ].ToLong ( &iValue );
        settingsBook->getMasterFilterTypesBox()->SetSelection( iValue );
    }

    if ( m.count(_T("MasterFilterBandLoSlider")) )
    {
        m [ _T("MasterFilterBandLoSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterBandLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterSlopeLoSlider")) )
    {
        m [ _T("MasterFilterSlopeLoSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterSlopeLoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterBandHiSlider")) )
    {
        m [ _T("MasterFilterBandHiSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterBandHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterSlopeHiSlider")) )
    {
        m [ _T("MasterFilterSlopeHiSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterSlopeHiSlider()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterCheckbox")) )
    {
        m [ _T("MasterFilterCheckbox") ].ToLong ( &iValue );
        settingsBook->getMasterFilterCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterModulationTypesBox")) )
    {
        m [ _T("MasterFilterModulationTypesBox") ].ToLong ( &iValue );
        settingsBook->getMasterFilterModulationTypesBox()->SetSelection( iValue );
    }

    if ( m.count(_T("MasterFilterModulationDepthSlider")) )
    {
        m [ _T("MasterFilterModulationDepthSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterModulationDepthSlider()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterLfoTypesBox")) )
    {
        m [ _T("MasterFilterLfoTypesBox") ].ToLong ( &iValue );
        settingsBook->getMasterFilterLfoTypesBox()->SetSelection( iValue );
    }

    if ( m.count(_T("MasterFilterLfoDepthSlider")) )
    {
        m [ _T("MasterFilterLfoDepthSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterLfoDepthSlider()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterLfoPeriodsPerSliceSlider")) )
    {
        m [ _T("MasterFilterLfoPeriodsPerSliceSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterLfoCheckbox") ))
    {
        m [ _T("MasterFilterLfoCheckbox") ].ToLong ( &iValue );
        settingsBook->getMasterFilterLfoCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterModulationCheckbox")) )
    {
        m [ _T("MasterFilterModulationCheckbox") ].ToLong ( &iValue );
        settingsBook->getMasterFilterModulationCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterResonanceCheckbox")) )
    {
        m [ _T("MasterFilterResonanceCheckbox") ].ToLong ( &iValue );
        settingsBook->getMasterFilterResonanceCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("MasterFilterResonanceSlider")) )
    {
        m [ _T("MasterFilterResonanceSlider") ].ToLong ( &iValue );
        settingsBook->getMasterFilterResonanceSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayMultiTapDistance")) )
    {
        m [ _T("delayMultiTapDistance") ].ToLong ( &iValue );
        settingsBook->getDelayMultiTapDistanceSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayMultiTapStepNo")) )
    {
        m [ _T("delayMultiTapStepNo") ].ToLong ( &iValue );
        settingsBook->getDelayMultiTapStepNoSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayMultiTapGain")) )
    {
        m [ _T("delayMultiTapGain") ].ToLong ( &iValue );
        settingsBook->getDelayMultiTapGainSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayMultiTapFeedback")) )
    {
        m [ _T("delayMultiTapFeedback") ].ToLong ( &iValue );
        settingsBook->getDelayMultiTapFeedbackSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayVariableDistance")) )
    {
        m [ _T("delayVariableDistance") ].ToLong ( &iValue );
        settingsBook->getDelayVariableDistanceSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayVariableGain")) )
    {
        m [ _T("delayVariableGain") ].ToLong ( &iValue );
        settingsBook->getDelayVariableGainSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayVariableFeedback")) )
    {
        m [ _T("delayVariableFeedback") ].ToLong ( &iValue );
        settingsBook->getDelayVariableFeedbackSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayVariableLfoTypesBox")) )
    {
        m [ _T("delayVariableLfoTypesBox") ].ToLong ( &iValue );
        settingsBook->getDelayVariableLfoTypesBox()->SetSelection( iValue );
    }

    if ( m.count(_T("delayVariableLfoDepth")) )
    {
        m [ _T("delayVariableLfoDepth") ].ToLong ( &iValue );
        settingsBook->getDelayVariableLfoDepthSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayVariableLfoPeriodsPerSlice")) )
    {
        m [ _T("delayVariableLfoPeriodsPerSlice") ].ToLong ( &iValue );
        settingsBook->getDelayVariableLfoPeriodsPerSliceSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayVariableCheckbox")) )
    {
        m [ _T("delayVariableCheckbox") ].ToLong ( &iValue );
        settingsBook->getDelayVariableCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T("retriggerCountSlider")) )
    {
        m [ _T("retriggerCountSlider") ].ToLong ( &iValue );
        settingsBook->getRetriggerCountSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayPhasingDistanceOffsetSlider")) )
    {
        m [ _T("delayPhasingDistanceOffsetSlider") ].ToLong ( &iValue );
        settingsBook->getDelayPhasingDistanceOffsetSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayPhasingDistanceRangeSlider")) )
    {
        m [ _T("delayPhasingDistanceRangeSlider") ].ToLong ( &iValue );
        settingsBook->getDelayPhasingDistanceRangeSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayPhasingGainSlider")) )
    {
        m [ _T("delayPhasingGainSlider") ].ToLong ( &iValue );
        settingsBook->getDelayPhasingGainSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayPhasingLfoTypesBox")) )
    {
        m [ _T("delayPhasingLfoTypesBox") ].ToLong ( &iValue );
        settingsBook->getDelayPhasingLfoTypesBox()->SetSelection( iValue );
    }

    if ( m.count(_T("delayPhasingLfoDepthSlider")) )
    {
        m [ _T("delayPhasingLfoDepthSlider") ].ToLong ( &iValue );
        settingsBook->getDelayPhasingLfoDepthSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayPhasingLfoPeriodsPerSliceSlider")) )
    {
        m [ _T("delayPhasingLfoPeriodsPerSliceSlider") ].ToLong ( &iValue );
        settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->SetValue( iValue );
    }

    if ( m.count(_T("delayPhasingCheckbox")) )
    {
        m [ _T("delayPhasingCheckbox") ].ToLong ( &iValue );
        settingsBook->getDelayPhasingCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T( "reverbRoomsizeSlider" )))
    {
        m [ _T( "reverbRoomsizeSlider" ) ].ToLong ( &iValue );
        settingsBook->getReverbRoomsizeSlider()->SetValue( iValue );
    }

    if ( m.count(_T( "reverbDampSlider" )))
    {
        m [ _T( "reverbDampSlider" ) ].ToLong ( &iValue );
        settingsBook->getReverbDampSlider()->SetValue( iValue );
    }

    if ( m.count(_T( "reverbDryMixSlider" )))
    {
        m [ _T( "reverbDryMixSlider" ) ].ToLong ( &iValue );
        settingsBook->getReverbDryMixSlider()->SetValue( iValue );
    }

    if ( m.count(_T( "reverbCheckbox" )))
    {
        m [ _T( "reverbCheckbox" ) ].ToLong ( &iValue );
        settingsBook->getReverbCheckbox()->SetValue( iValue );
    }

    if ( m.count(_T( "auxCheckbox" )))
    {
        m [ _T( "auxCheckbox" ) ].ToLong ( &iValue );
        settingsBook->getAuxCheckbox()->SetValue( iValue );
    }

    if ( m.count( _T( "matchBpmBeatsSlider" )))
    {
        m [ _T( "matchBpmBeatsSlider") ].ToLong ( &iValue );
        settingsBook->getMatchBpmBeatsSlider()->SetValue( iValue );
    }

    if ( m.count( _T ( "matchBpmTargetBpmSlider" )))
    {
        m [ _T( "matchBpmTargetBpmSlider") ].ToLong ( &iValue );
        settingsBook->getMatchBpmTargetBpmSlider()->SetValue( iValue );
    }

    if ( m.count( _T ( "matchBpmCheckbox" )))
    {
        m [ _T( "matchBpmCheckbox" ) ].ToLong ( &iValue );
        settingsBook->getMatchBpmCheckbox()->SetValue( iValue );
    }

    if ( m.count( _T ( "declickCheckbox" )))
    {
        m [ _T( "declickCheckbox" ) ].ToLong ( &iValue );
        settingsBook->getDeclickCheckbox()->SetValue( iValue );
    }

    if ( m.count( _T ( "enhanceCheckbox" )))
    {
        m [ _T( "enhanceCheckbox" ) ].ToLong ( &iValue );
        settingsBook->getEnhanceCheckbox()->SetValue( iValue );
    }

    if ( m.count( _T ( "eqCheckbox" )))
    {
        m [ _T( "eqCheckbox" ) ].ToLong ( &iValue );
        settingsBook->getEqCheckbox()->SetValue( iValue );
    }

    if ( m.count( _T ( "eqLowGainSlider" )))
    {
        m [ _T( "eqLowGainSlider") ].ToLong ( &iValue );
        settingsBook->getEqLowGainSlider()->SetValue( iValue );
    }

    if ( m.count( _T ( "eqMidGainSlider" )))
    {
        m [ _T( "eqMidGainSlider") ].ToLong ( &iValue );
        settingsBook->getEqMidGainSlider()->SetValue( iValue );
    }

    if ( m.count( _T ( "eqHighGainSlider" )))
    {
        m [ _T( "eqHighGainSlider") ].ToLong ( &iValue );
        settingsBook->getEqHighGainSlider()->SetValue( iValue );
    }

    manager->Update();
    mapGrid->Refresh();
    effectsGrid->Refresh();
    progressGrid->reset();

    if ( viewSettingsState )
        settingsBook->initPlotAreas();

    if ( !newData )
        return;

    pathValid = DoOpen ( w, fileIn );
    if ( pathValid )
        updateTitle ( fileIn );

}

void smasherFrame::OnAbout (wxCommandEvent &event)
{
    wxAboutDialogInfo info;
#ifndef __WXMSW__
    wxIcon icon;
    icon.CopyFromBitmap ( wxBitmap ( AppIcon::getPath(), wxBITMAP_TYPE_PNG ) );
    info.SetIcon ( icon );
#endif
    info.SetName(_("smasher") );
    info.SetVersion( SMASHER_VERSION_STRING );
    info.SetDescription( SMASHER_ABOUT_DESCRIPTION );
    info.AddDeveloper(_T("esther loeliger <eloeliger@users.sourceforge.net>"));
    info.AddDeveloper(_T("gerald schmidt <gnschmidt@users.sourceforge.net>"));
    info.SetCopyright(_T("copyright (c) 2009"));
    info.SetWebSite(_("http://smasher.sourceforge.net"));
    wxGenericAboutBox(info);
}

void smasherFrame::OnClose (wxCloseEvent &event)
{
    std::vector<wxString>::iterator it;
    for ( it = tempFiles.begin(); it != tempFiles.end(); it++ )
        wxRemove ( *it );

    Destroy();
}

#ifdef __WXMSW__
void smasherFrame::OnDropFiles ( wxDropFilesEvent& event )
{
    int no = event.GetNumberOfFiles();
    wxString *iterator = event.GetFiles();
    if ( !no || !iterator )
        return;

    for ( int i = 0; i < no; i++, iterator++ )
    {
        fileIn = *iterator;
        break;
    }

    pathValid = DoOpen ( w, fileIn );
    if ( pathValid )
        updateTitle ( fileIn );
}
#endif

void smasherFrame::OnGridColLeftClick ( wxGridEvent& event )
{
    waitForThreadsToFinish();

    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    int row, col;
    row = event.GetRow();
    col = event.GetCol();
    if ( row != -1 || col == -1 )
        return;

    std::vector<double> slice;
    std::string fileName;
    wxString wideFileName;

    WrapTempFileName wtfn;
    wtfn.setKeepFiles ( true );
    fileName = wtfn.name();
    wideFileName = wtfn.wideName();

    wideFileName += _T(".wav");
    fileName += ".wav";

    tempFiles.push_back ( wideFileName );

    size_t gateRange = 128;
    w->getSlice ( ( size_t )col, slice, gateRange );

    SliceNormalizeTransformer<double> *snt;
    snt = new SliceNormalizeTransformer<double> ( ( double ) volumeSlider->GetValue() * 0.1 );
    std::vector<double> left, right;
    SampleMath::splitChannels ( &slice, &left, &right );
    snt->transform ( &left, &right );
    SampleMath::joinChannels ( &left, &right, &slice );
    delete snt;

    w->writeRawData ( (char *)fileName.c_str(), slice );

    progressGrid->setColumn ( col );

    play ( wideFileName );
    slicePlayState = true;

    /*wxSound sound ( wideFileName );
    if ( sound.IsOk() )
        sound.Play ( );*/
}

void smasherFrame::OnFxOrderClear (wxCommandEvent& event)
{
    DoClearOrder ( effectsGrid );
}

void smasherFrame::OnFxOrderSticky ( wxCommandEvent& event)
{
    DoFxOrderSticky();
}

void smasherFrame::OnIdle ( wxIdleEvent& event)
{
    if ( ++idleCounter % 2 )
        return;

    DoIdle();
}

//tbd exp
void smasherFrame::OnKeyDown ( wxKeyEvent& event )
{
    int key = event.GetKeyCode();
    switch ( key )
    {
    case WXK_TAB:
        if ( FindFocus() == ( wxWindow * ) sliceNoSpinControl )
            mapGrid->SetFocus();
        break;
    default:
        break;
    }
}

void smasherFrame::OnLoop (wxCommandEvent& event)
{
    DoLoop();
}

void smasherFrame::OnMediaFinished(wxMediaEvent& event)
{
    DoMediaFinished();
}

void smasherFrame::OnMediaLoaded(wxMediaEvent& event)
{
    DoMediaLoaded();
}

void smasherFrame::OnMediaStateChanged(wxMediaEvent& event)
{
    if ( closeDown )
        return;

    wxString state;
    switch ( getCurrentMediaCtrl()->GetState() )
    {
    case wxMEDIASTATE_PLAYING:
        state = _("playing");
        if ( isPlaySmashedButton )
            toolbar->ToggleTool ( ID_PLAY_SMASHED, true );
        else
            toolbar->ToggleTool ( ID_PLAY, true );
        toolbar->Realize();
        break;
    case wxMEDIASTATE_STOPPED:
        state = _("stopped");
        toolbar->ToggleTool ( ID_PLAY, false );
        toolbar->ToggleTool ( ID_PLAY_SMASHED, false );
        toolbar->Realize();
        gridColumnMemory = -1;
        progressGrid->reset();
        if ( slicePlayState )
            slicePlayState = false;
        break;
    case wxMEDIASTATE_PAUSED:
        state = _("paused");
        break;
    default:
        state = wxEmptyString;
        break;
    }
    SetStatusText ( state, STATUS_PLAYBACK );
}

void smasherFrame::OnOpen (wxCommandEvent& event)
{
    wxString drive, directory;
    wxFileName::SplitPath ( fileIn, &drive, &directory, NULL, NULL );
    directory =
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory;

    wxFileDialog fd ( this, _("Choose a file"), directory, wxEmptyString,
#ifdef __WXMSW__
                      _("All files (*.*)|*.*|WAV files (*.wav)|*.wav|MP3 files (*.mp3)|*.mp3|AIFF files (*.aiff)|*.aiff|FLAC files (*.flac)|*.flac")
#else
                      _("All files (*.*)|*|WAV files (*.wav)|*.wav|MP3 files (*.mp3)|*.mp3|AIFF files (*.aiff)|*.aiff|FLAC files (*.flac)|*.flac")
#endif

                    );
    if ( fd.ShowModal () == wxID_CANCEL )
        return;
    fileIn = fd.GetPath();
    pathValid = DoOpen ( w, fileIn );
    if ( pathValid )
        updateTitle ( fileIn );

}

void smasherFrame::OnHistoryFile ( wxCommandEvent& event )
{
    wxString file ( fileHistory.GetHistoryFile ( event.GetId() - wxID_FILE1 ) );
    if ( !file.empty() )
        DoOpen ( w, file );
}

void smasherFrame::OnPause ( wxCommandEvent& event )
{
    DoPause();
}

void smasherFrame::OnPlay (wxCommandEvent& event)
{
    isPlaySmashedButton = false;
    changedWhilePlaying = false;

    if ( toolbar->GetToolToggled ( ID_PLAY_SMASHED ) )
        toolbar->ToggleTool ( ID_PLAY_SMASHED, false );

    std::string file = (const char *) fileIn.mb_str( wxConvUTF8 );
    handleMp3 ( file );
    wxString wideFile = wxString ( file.c_str(), wxConvUTF8, file.size() );
    if ( !play ( wideFile /*, loopState */ ) )
        return;
    toolbar->ToggleTool ( ID_PLAY, true );
    toolbar->Realize();
}

void smasherFrame::OnPlaySmashed (wxCommandEvent& event)
{

    int colNo, rowNo;
    colNo = mapGrid->GetNumberCols();
    rowNo = mapGrid->GetNumberRows();

    isPlaySmashedButton = true;
    changedWhilePlaying = false;
    if ( toolbar->GetToolToggled ( ID_PLAY ) )
        toolbar->ToggleTool ( ID_PLAY, false );

    if ( !DoPlaySmashed ( -1 ) )
        return;
    toolbar->ToggleTool ( ID_PLAY_SMASHED, true );
    toolbar->Realize();
}

void smasherFrame::OnRestoreDefault ( wxCommandEvent& event)
{
    //wxString state = defaultStates->at ( settingsBook->getDefaultTypesBox()->GetSelection() );
    //loadState ( state, true );
    int index = settingsBook->getFactoryListView()->GetFirstSelected();
    settingsBook->DoListViewItemActivated( index );
}

void smasherFrame::OnQuit (wxCommandEvent &event)
{
    Destroy();
}

void smasherFrame::OnSave ( wxCommandEvent& event )
{
    wxString drive, directory;
    wxFileName::SplitPath ( fileIn, &drive, &directory, NULL, NULL );
    directory =
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory;


    std::auto_ptr<wxFileDialog> fd ( new wxFileDialog (
                                         this,
                                         _ ( "Save As" ),
                                         directory,
                                         wxEmptyString,
#ifdef __WXMSW__
                                         _T("All files (*.*)|*.*|WAV files (*.wav)|*.wav")
#else
                                         _T("All files (*.*)|*|WAV files (*.wav)|*.wav")
#endif
                                         , wxSAVE | wxOVERWRITE_PROMPT ) );
    if ( fd->ShowModal() != wxID_OK )
        return;

    wxString path = fd->GetPath();

    int index = fd->GetFilterIndex();
    wxString filter;
    switch ( index )
    {
    case 0:
    case 1:
        filter = _T(".wav");
        break;
    default:
        filter = _T(".wav");
        break;
    }

    if ( ! path.Lower().Contains ( filter ) )
        path.Append ( filter );

    waitForThreadsToFinish();

    if ( w->getState() != WAV16_HAS_DATA_OUT )
    {
        std::cout << "OnSave: w->getState() != WAV16_HAS_DATA_OUT" << std::endl;
        SetStatusText ( _("can't save ") + path );
        return;
    }

    std::string fileOut;

    if ( path.empty() )
        return;

    fileOut = (const char *) path.mb_str( wxConvUTF8 );

    if ( !w->write ( ( char * ) fileOut.c_str() ))
        SetStatusText ( _("can't write file to disk" ) );

}

void smasherFrame::OnSharePreset ( wxCommandEvent& event )
{
    wxString title;
    title = _T( "share preset");

    ShareDialog sd ( this, title, sharePreset, shareAuthor, sharePasscode, shareEmail, fileIn, saveState() );

    if ( sd.ShowModal() == wxID_OK )
        settingsBook->refreshPresets();
}

void smasherFrame::OnLoadMachineState ( wxCommandEvent& event )
{
    wxFileDialog fd ( this, _("Load machine state"), wxEmptyString, wxEmptyString,
#ifdef __WXMSW__
                      _("All files (*.*)|*.*|SMASH files (*.smash)|*.smash")
#else
                      _("All files (*.*)|*|SMASH files (*.smash)|*.smash")
#endif
                    );
    if ( fd.ShowModal () == wxID_CANCEL )
        return;

    wxString statePath = fd.GetPath();
    if ( statePath.empty() )
        return;

    DoLoadMachineState ( statePath );
}

bool smasherFrame::DoLoadMachineState ( const wxString& path )
{
    try {
        BinaryFile bf ( path.mb_str( wxConvUTF8 ) );
        wxString state = wxString ( bf.getData(), wxConvUTF8, bf.getDataLen() );
        loadState ( state, true );
    }
    catch (...)
    {
        return false;
    }
    return true;
}

void smasherFrame::OnSaveMachineState(wxCommandEvent& event)
{
    std::auto_ptr<wxFileDialog> fd ( new wxFileDialog (
                                         this,
                                         _ ( "Save machine state" ),
                                         wxEmptyString,
                                         wxEmptyString,
                                         _T("*.smash"),
                                         wxSAVE | wxOVERWRITE_PROMPT ) );
    if ( fd->ShowModal() != wxID_OK )
        return;

    wxString path = fd->GetPath();
    if ( path.empty() )
        return;

    int index = fd->GetFilterIndex();
    wxString filter;
    switch ( index )
    {
    case 0:
        filter = _T(".smash");
        break;
    default:
        filter = _T(".smash");
        break;
    }

    if ( ! path.Lower().Contains ( filter ) )
        path.Append ( filter );


    wxString state = saveState();

    std::string fileOutName;
    fileOutName = (const char *) path.mb_str( wxConvUTF8 );
    std::ofstream file ( fileOutName.c_str() );
    if ( !file.is_open() )
    {
        SetStatusText ( _("can't save machine state") );
        return;
    }
    file << ( const char *) state.mb_str( wxConvUTF8 );
    file.close();
    SetStatusText ( _("saved machine state to disk") );
}

void smasherFrame::OnSettingsChanged (wxTreebookEvent& event)
{
    event.Skip();
}

void smasherFrame::OnShowLog (wxCommandEvent& event)
{
    DoShowLog ();
}

void smasherFrame::OnShowSettings (wxCommandEvent& event)
{
    DoShowSettings ();
}

void smasherFrame::OnShowTransportOnly ( wxCommandEvent& event)
{
    DoShowTransportOnly ();
}

void smasherFrame::OnShowHelp ( wxCommandEvent& event)
{
    DoShowHelp();
}

void smasherFrame::OnSliceNoChange (wxSpinEvent& event)
{
    DoSliceNoChange ();
}

void smasherFrame::OnSliceOrder1ToN (wxCommandEvent& event)
{
    DoSliceOrder1ToN ( mapGrid );
}

void smasherFrame::OnSliceOrderClear (wxCommandEvent& event)
{
    DoClearOrder( mapGrid );
    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ));
    DoClearOrder ( effectsGrid );
}

void smasherFrame::OnSliceOrderNTo1 (wxCommandEvent& event)
{
    DoSliceOrderNTo1 ( mapGrid );
}

void smasherFrame::OnSliceOrderShuffleAll (wxCommandEvent& event)
{
    DoSliceOrderShuffleAll ( mapGrid );
}

void smasherFrame::OnSliceOrderShuffleByKey (wxCommandEvent& event)
{
    DoSliceOrderShuffleByKey ( mapGrid );
}

void smasherFrame::OnSliceOrderRotateLeft (wxCommandEvent& event)
{
    mapGrid->rotateLeft();
    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        effectsGrid->rotateLeft();

    manager->Update ();
}

void smasherFrame::OnSliceOrderRotateRight (wxCommandEvent& event)
{
    mapGrid->rotateRight();
    if ( mapToolbar->GetToolToggled ( ID_FX_ORDER_STICKY ) )
        effectsGrid->rotateRight();
    manager->Update ();
}

#ifndef __WXMSW__
void smasherFrame::OnVolumeChanged ( wxScrollEvent& event )
#else
void smasherFrame::OnVolumeChanged ( wxSpinEvent& event )
#endif
{
    DoVolumeChanged();
}

void smasherFrame::OnTogglePlay(wxCommandEvent& event)
{
    // play - stop
    if ( getCurrentMediaCtrl()->GetState() == wxMEDIASTATE_PLAYING )
    {
        OnStop ( event );
        return;
    }
    else if ( isPlaySmashedButton )
    {
        OnPlaySmashed ( event );
        return;
    }
    OnPlay ( event );

    // play - pause
    /*if ( pauseState || toolbar->GetToolToggled( ID_PLAY ) || toolbar->GetToolToggled( ID_PLAY_SMASHED ))
    {
        OnPause ( event );
        return;
    }
    if ( isPlaySmashedButton )
    {
        OnPlaySmashed ( event );
        return;
    }
    OnPlay ( event );*/
}


void smasherFrame::OnStop (wxCommandEvent& event)
{
    changedWhilePlaying = false;
    DoStop();
}

void smasherFrame::OnRedo ( wxCommandEvent& event)
{
    wxString newState = history.redo();
    if ( ! newState.empty() )
    {
        loadState ( newState );
    }
    stateMemory = newState;

    waitForThreadsToFinish();
    smashSync( w );
    updatePlotArea();
}

void smasherFrame::OnUndo ( wxCommandEvent& event)
{
    wxString newState = history.undo();
    if ( ! newState.empty() )
    {
        loadState ( newState );
    }
    stateMemory = newState;

    waitForThreadsToFinish();
    smashSync( w );
    updatePlotArea();
}

void smasherFrame::OnUpdateRedo ( wxUpdateUIEvent& event )
{
    event.Enable ( history.canRedo() );
}

void smasherFrame::OnUpdateUndo ( wxUpdateUIEvent& event )
{
    event.Enable ( history.canUndo() );
}

void smasherFrame::OnUpdateThreadRunning ( wxUpdateUIEvent& event )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );
    event.Enable ( threadState != SMASH_THREAD_RUNNING );
}

void smasherFrame::OnUpdatePaneMaximized ( wxUpdateUIEvent& event )
{
    bool enable;
    if ( toolbar->GetToolToggled ( ID_SHOW_TRANSPORT_ONLY ) )
        enable = false;
    else
        enable = !paneIsMaximized();

    event.Enable( enable );
}

bool smasherFrame::paneIsMaximized()
{
    return (
#ifdef SMASHER_DEBUG
               ( manager->GetPane( logText ).IsMaximized()) ||
#endif
               ( manager->GetPane( mapGrid ).IsMaximized()));
}

bool smasherFrame::play (wxString& fileName /* , bool loop */ )
{
    try
    {
        if ( pauseState )
        {
            mediaCtrl->Stop();
            mediaCtrlAlt->Stop();
            DoPause();
        }

        if ( !getCurrentMediaCtrl()->Load ( fileName ) )
        {
            std::cout << "play: media ctrl can't load wave" << std::endl;
            return false;
        }

        if ( !getAlternativeMediaCtrl()->Load ( fileName ) )
        {
            std::cout << "play: alternative media ctrl can't load wave" << std::endl;
            return false;
        }

        return true;

        /* wxSound implementation
            if ( fileName.empty() ) {
                throw std::runtime_error ( "smasherFrame::play() - empty fileName" );
            }
            wxSound s ( fileName );
            if ( ! s.IsOk() )
            {
                throw std::runtime_error ( "smasherFrame::play() - can't load fileIn" );
            }
            return s.Play ( loop ? wxSOUND_ASYNC | wxSOUND_LOOP : wxSOUND_ASYNC );
         */
    }
    catch (std::exception &e)
    {
        std::cout << "play: " << e.what() << std::endl;
        return false;
    }
}

void smasherFrame::addTransformers( Wav16Smash *wav, std::vector<size_t>& posVector )
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    wav->clearEffectsInfo();

    std::vector<wxString> chainVector;

    settingsBook->getEffectsChainBox()->getChainVector ( &chainVector );

    if ( chainVector.empty() )
        return;

    size_t chainVectorSize = chainVector.size();
    wxString currentEffect;
    std::vector<size_t> effectsPositionVector;
    for ( size_t i = 0; i < chainVectorSize; i++ )
    {
        currentEffect = chainVector.at ( i );
        effectsPositionVector.clear();

        if ( currentEffect == _("master distort") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *distortTransformer;
                double pregain, postgain, cutoff;
                pregain = settingsBook->getDistortPregainSlider()->GetValue() * 0.01;
                postgain = settingsBook->getDistortPostgainSlider()->GetValue() * 0.01;
                cutoff = settingsBook->getDistortCutoffSlider()->GetValue();

                distortTransformer = ( SliceTransformer<double> * )
                                     new SliceDistortTransformer<double> (
                                         pregain,
                                         postgain,
                                         cutoff,
                                         ( size_t ) settingsBook->getDistortFeedbackSlider()->GetValue(),
                                         ( double ) settingsBook->getDistortToneShaping1Slider()->GetValue() * 0.5 / 22050,
                                         ( double ) settingsBook->getDistortToneShaping2Slider()->GetValue() * 0.5 / 22050,
                                         wav->getChannels() );
                SliceVectorTransformer<double> *distortTransformerV;
                distortTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    distortTransformer );
                wav->addSliceVectorTransformer ( distortTransformerV );
            }
        }

        else if ( currentEffect == _("reverse") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *reverseTransformer;
                reverseTransformer = ( SliceTransformer<double> * )
                                     new SliceReverseTransformer<double>( wav->getChannels () );
                SliceVectorTransformer<double> *reverseTransformerV;
                reverseTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    reverseTransformer );
                wav->addSliceVectorTransformer ( reverseTransformerV );
            }
        }

        else if ( currentEffect == _( "bitcrush" ) )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *bitCrushTransformer;
                bitCrushTransformer = ( SliceTransformer<double> * )
                                      new SliceBitCrushTransformer<double> (
                                          settingsBook->getBitCrushTypesBox()->GetSelection(),
                                          wav->getChannels () );
                SliceVectorTransformer<double> *bitCrushTransformerV;
                bitCrushTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    bitCrushTransformer);
                wav->addSliceVectorTransformer ( bitCrushTransformerV );
            }
        }

        else if ( currentEffect == _("tap delay") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                double delay = (double)( settingsBook->getDelayMultiTapDistanceSlider()->GetValue() ) * 0.01;
                size_t steps = settingsBook->getDelayMultiTapStepNoSlider()->GetValue();
                double gain =  settingsBook->getDelayMultiTapGainSlider()->GetValue() * 0.1;
                size_t feedbackLoops = ( size_t ) settingsBook->getDelayMultiTapFeedbackSlider()->GetValue();
                SliceTransformer<double> *delayTransformer;
                delayTransformer = ( SliceTransformer<double> * )
                                   new SliceDelayTransformer<double> (
                                       delay,
                                       steps,
                                       gain,
                                       feedbackLoops,
                                       wav->getChannels () );
                SliceVectorTransformer<double>  *delayTransformerV;
                delayTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayTransformer);
                wav->addSliceVectorTransformer ( delayTransformerV );
            }
        }

        else if ( currentEffect == _("retrigger") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *retriggerTransformer;
                retriggerTransformer = ( SliceTransformer<double> * )
                                       new SliceRetriggerTransformer<double> (
                                           settingsBook->getRetriggerCountSlider()->GetValue() );
                SliceVectorTransformer<double>  *retriggerTransformerV;
                retriggerTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    retriggerTransformer);
                wav->addSliceVectorTransformer ( retriggerTransformerV );
            }
        }

        else if ( currentEffect == _( "master flanger" ) )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );

            if ( !effectsPositionVector.empty() )
            {
                size_t delay = ( size_t ) settingsBook->getDelayVariableDistanceSlider()->GetValue();
                size_t feedbackLoopNo = ( size_t ) settingsBook->getDelayVariableFeedbackSlider()->GetValue();
                int lfoType = settingsBook->getDelayVariableLfoTypesBox()->GetSelection();
                double gain =  ( double ) settingsBook->getDelayVariableGainSlider()->GetValue() * 0.1;
                double lfoDepth = ( double ) settingsBook->getDelayVariableLfoDepthSlider()->GetValue() * 0.01;
                double lfoPeriodsPerSlice = ( double ) settingsBook->getDelayVariableLfoPeriodsPerSliceSlider()->GetValue() * 0.01;
                SliceTransformer<double> *delayVariableTransformer;
                delayVariableTransformer = ( SliceTransformer<double> * )
                                           new SliceDelayVariableTransformer<double> (
                                               delay,
                                               feedbackLoopNo,
                                               wav->getChannels (),
                                               lfoType,
                                               gain,
                                               lfoDepth,
                                               lfoPeriodsPerSlice );
                SliceVectorTransformer<double> *delayVariableTransformerV;
                delayVariableTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayVariableTransformer);
                wav->addSliceVectorTransformer ( delayVariableTransformerV );
            }
        }

        else if ( currentEffect == _( "master phaser" ) )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );

            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *delayPhaseTransformer;
                delayPhaseTransformer = ( SliceTransformer<double> * )
                                        new SliceDelayPhaseTransformer<double> (
                                            (( double ) settingsBook->getDelayPhasingDistanceOffsetSlider()->GetValue() )/ 22050.0,
                                            (( double ) settingsBook->getDelayPhasingDistanceRangeSlider()->GetValue() )/ 22050.0,
                                            settingsBook->getDelayPhasingLfoTypesBox()->GetSelection(),
                                            ( double ) settingsBook->getDelayPhasingLfoDepthSlider()->GetValue() * 0.01,
                                            ( double ) settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->GetValue() * 0.01,
                                            wav->getChannels(),
                                            ( double ) settingsBook->getDelayPhasingGainSlider()->GetValue() * 0.1,
                                            0 );

                SliceVectorTransformer<double> *delayPhaseTransformerV;
                delayPhaseTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayPhaseTransformer);
                wav->addSliceVectorTransformer ( delayPhaseTransformerV );
            }
        }

        else if ( currentEffect == _("downsample") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *downSampleTransformer;
                downSampleTransformer = ( SliceTransformer<double> * )
                                        new SliceDownSampleTransformer<double> (
                                            settingsBook->getDownSampleTypesBox()->GetSelection(),
                                            wav->getChannels () );
                SliceVectorTransformer<double> *downSampleTransformerV;
                downSampleTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    downSampleTransformer);
                wav->addSliceVectorTransformer ( downSampleTransformerV );
            }
        }

        else if ( currentEffect == _("tapestop") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *tapestopTransformer;
                tapestopTransformer = ( SliceTransformer<double> * )
                                      new SliceTapestopTransformer<double> ( wav->getChannels () );
                SliceVectorTransformer<double> *tapestopTransformerV;
                tapestopTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    tapestopTransformer);
                wav->addSliceVectorTransformer ( tapestopTransformerV );
            }
        }

        else if ( currentEffect == _("fade in") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fadeInTransformer;
                fadeInTransformer = ( SliceTransformer<double> * )
                                    new SliceFadeTransformer<double> (
                                        settingsBook->getFadeInRangeSlider()->GetValue(),
                                        wav->getChannels (),
                                        FADE_IN,
                                        settingsBook->getFadeInTypesBox()->GetSelection() );
                SliceVectorTransformer<double> *fadeInTransformerV;
                fadeInTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    fadeInTransformer);
                wav->addSliceVectorTransformer ( fadeInTransformerV );
            }
        }

        else if ( currentEffect == _("fade out") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fadeOutTransformer;
                fadeOutTransformer = ( SliceTransformer<double> * )
                                     new SliceFadeTransformer<double> (
                                         settingsBook->getFadeOutRangeSlider()->GetValue(),
                                         wav->getChannels (),
                                         FADE_OUT,
                                         settingsBook->getFadeOutTypesBox()->GetSelection() );
                SliceVectorTransformer<double> *fadeOutTransformerV;
                fadeOutTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    fadeOutTransformer);
                wav->addSliceVectorTransformer ( fadeOutTransformerV );
            }
        }

        else if ( currentEffect == _("tremolo") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *tremoloTransformer;
                tremoloTransformer = ( SliceTransformer<double> * )
                                     new SliceTremoloTransformer<double> (
                                         settingsBook->getTremoloTypesBox()->GetSelection(),
                                         (double)( settingsBook->getTremoloDepthSlider()->GetValue() ) * 0.01,
                                         settingsBook->getTremoloPeriodsPerSliceSlider()->GetValue(),
                                         settingsBook->getTremoloStereoModeBox()->GetSelection(),
                                         wav->getChannels () );
                SliceVectorTransformer<double> *tremoloTransformerV;
                tremoloTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    tremoloTransformer);
                wav->addSliceVectorTransformer ( tremoloTransformerV );
            }
        }

        else if ( currentEffect == _("phasing") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *delayPhaseTransformer;
                delayPhaseTransformer = ( SliceTransformer<double> * )
                                        new SliceDelayPhaseTransformer<double> (
                                            settingsBook->getTremoloTypesBox()->GetSelection(),
                                            (double)( settingsBook->getTremoloDepthSlider()->GetValue() ) * 0.01,
                                            settingsBook->getTremoloPeriodsPerSliceSlider()->GetValue(),
                                            wav->getChannels () );
                SliceVectorTransformer<double> *delayPhaseTransformerV;
                delayPhaseTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayPhaseTransformer);
                wav->addSliceVectorTransformer ( delayPhaseTransformerV );
            }
        }

        else if ( currentEffect == _("pan delay") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *delayPanTransformer;
                delayPanTransformer = ( SliceTransformer<double> * )
                                      new SliceDelayPanTransformer<double> (
                                          0.3,
                                          0.6,
                                          wav->getChannels () );
                SliceVectorTransformer<double> *delayPanTransformerV;
                delayPanTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    delayPanTransformer);
                wav->addSliceVectorTransformer ( delayPanTransformerV );
            }
        }

        else if ( currentEffect == _("lowpass") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftLowPassTransformer;
                fftLowPassTransformer = ( SliceTransformer<double> * )
                                        new SliceFFTTransformer<double> (
                                            FFT_LOWPASS,
                                            0.0,
                                            0.0,
                                            ( settingsBook->getFftLowPassBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                            ( settingsBook->getFftLowPassSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                            wav->getChannels () );

                SliceVectorTransformer<double> *fftLowPassTransformerV;
                fftLowPassTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftLowPassTransformer );
                wav->addSliceVectorTransformer ( fftLowPassTransformerV );
            }
        }

        else if ( currentEffect == _("highpass") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftHiPassTransformer;
                fftHiPassTransformer = ( SliceTransformer<double> * )
                                       new SliceFFTTransformer<double> (
                                           FFT_HIGHPASS,
                                           ( settingsBook->getFftHighPassBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                           ( settingsBook->getFftHighPassSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                           0 * 0.5 / 22050,
                                           0 * 0.5 / 22050,
                                           wav->getChannels () );
                SliceVectorTransformer<double> *fftHiPassTransformerV;
                fftHiPassTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftHiPassTransformer );
                wav->addSliceVectorTransformer ( fftHiPassTransformerV );
            }
        }

        else if ( currentEffect == _("bandpass") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftBandPassTransformer;
                fftBandPassTransformer = ( SliceTransformer<double> * )
                                         new SliceFFTTransformer<double> (
                                             FFT_BANDPASS,
                                             ( settingsBook->getFftBandPassBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getFftBandPassSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getFftBandPassBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getFftBandPassSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                             wav->getChannels () );
                SliceVectorTransformer<double> *fftBandPassTransformerV;
                fftBandPassTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftBandPassTransformer );
                wav->addSliceVectorTransformer ( fftBandPassTransformerV );
            }
        }

        else if ( currentEffect == _("bandstop") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *fftBandStopTransformer;
                fftBandStopTransformer = ( SliceTransformer<double> * )
                                         new SliceFFTTransformer<double> (
                                             FFT_BANDSTOP,
                                             ( settingsBook->getFftBandStopBandLoSlider()->GetValue()) * 0.5 / 22050,
                                             ( settingsBook->getFftBandStopSlopeLoSlider()->GetValue()) * 0.5 / 22050,
                                             ( settingsBook->getFftBandStopBandHiSlider()->GetValue()) * 0.5 / 22050,
                                             ( settingsBook->getFftBandStopSlopeHiSlider()->GetValue()) * 0.5 / 22050,
                                             wav->getChannels () );
                SliceVectorTransformer<double> *fftBandStopTransformerV;
                fftBandStopTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    fftBandStopTransformer );
                wav->addSliceVectorTransformer ( fftBandStopTransformerV );
            }
        }

        else if ( currentEffect == _("master reverb") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *reverbTransformer;
                double roomsize, damp, dryMix;
                roomsize = ( settingsBook->getReverbRoomsizeSlider()->GetValue() ) / 100.0;
                damp = ( settingsBook->getReverbDampSlider()->GetValue() ) / 100.0;
                dryMix = ( settingsBook->getReverbDryMixSlider()->GetValue() ) / 100.0;
                reverbTransformer = ( SliceTransformer<double> * )
                                    new SliceReverbTransformer<double> (
                                        roomsize,
                                        damp,
                                        dryMix,
                                        wav->getChannels () );
                SliceVectorTransformer<double> *reverbTransformerV;
                reverbTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    reverbTransformer );
                wav->addSliceVectorTransformer ( reverbTransformerV );
            }
        }

        else if ( currentEffect == _("master aux") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                SliceTransformer<double> *auxTransformer;
                auxTransformer = ( SliceTransformer<double> * )
                                 new SliceAuxTransformer<double> (
                                     userAuxCsdFile,
                                     wav->getChannels () );
                SliceVectorTransformer<double> *auxTransformerV;
                auxTransformerV = new SliceVectorTransformer<double> (
                    effectsPositionVector,
                    auxTransformer );
                wav->addSliceVectorTransformer ( auxTransformerV );
            }
        }

        else if ( currentEffect == _("master filter") )
        {
            effectsGrid->getNamedPositionVector ( currentEffect, effectsPositionVector );
            if ( !effectsPositionVector.empty() )
            {
                double resonanceMax, modulationDepth, lfoDepth;
                int modulationType, lfoType;
                size_t lfoPeriodsPerSlice = 0;
                modulationType = FFT_MOD_NONE;
                lfoType = FFT_LFO_NONE;
                resonanceMax = modulationDepth = lfoDepth = 0.0;

                if ( settingsBook->getMasterFilterResonanceCheckbox()->IsChecked() )
                    resonanceMax = settingsBook->getMasterFilterResonanceSlider()->GetValue();

                if ( settingsBook->getMasterFilterModulationCheckbox()->IsChecked() )
                {
                    modulationType = settingsBook->getMasterFilterModulationTypesBox()->GetSelection();
                    modulationDepth = settingsBook->getMasterFilterModulationDepthSlider()->GetValue() * 0.01;
                }

                if ( settingsBook->getMasterFilterLfoCheckbox()->IsChecked() )
                {
                    lfoType = settingsBook->getMasterFilterLfoTypesBox()->GetSelection(),
                              lfoDepth = settingsBook->getMasterFilterLfoDepthSlider()->GetValue() * 0.01;
                    lfoPeriodsPerSlice = settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->GetValue();
                }

                SliceTransformer<double> *masterFilterTransformer;
                masterFilterTransformer = ( SliceTransformer<double> * )
                                          new SliceFFTWindowedTransformer<double> (
                                              settingsBook->getMasterFilterTypesBox()->GetSelection(),
                                              modulationType,
                                              lfoType,
                                              ( settingsBook->getMasterFilterBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                              ( settingsBook->getMasterFilterSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                              ( settingsBook->getMasterFilterBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                              ( settingsBook->getMasterFilterSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                              1024,
                                              modulationDepth,
                                              lfoDepth,
                                              resonanceMax,
                                              lfoPeriodsPerSlice,
                                              wav->getChannels () );

                SliceVectorTransformer<double> *masterFilterTransformerV;
                masterFilterTransformerV = new SliceVectorTransformer<double>(
                    effectsPositionVector,
                    masterFilterTransformer);
                wav->addSliceVectorTransformer ( masterFilterTransformerV );
            }
        }
    }


    /************ F I L T E R ***********************************************************/
    chainVector.clear();

    settingsBook->getFinishingChainBox()->getChainVector ( &chainVector );

    if ( chainVector.empty() )
        return;

    chainVectorSize = chainVector.size();
    wxString currentFinishing;

    for ( size_t i = 0; i < chainVectorSize; i++ )
    {
        currentFinishing = chainVector.at ( i );

        if ( currentFinishing == _("master distort") )
        {
            if ( settingsBook->getDistortCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *mDistortTransformer;
                double pregain, postgain, cutoff;
                pregain = settingsBook->getDistortPregainSlider()->GetValue() * 0.01;
                postgain = settingsBook->getDistortPostgainSlider()->GetValue() * 0.01;
                cutoff = settingsBook->getDistortCutoffSlider()->GetValue();

                mDistortTransformer = ( SliceTransformer<double> * )
                                      new SliceDistortTransformer<double> (
                                          pregain,
                                          postgain,
                                          cutoff,
                                          ( size_t ) settingsBook->getDistortFeedbackSlider()->GetValue(),
                                          ( double ) settingsBook->getDistortToneShaping1Slider()->GetValue() * 0.5 / 22050,
                                          ( double ) settingsBook->getDistortToneShaping2Slider()->GetValue() * 0.5 / 22050,
                                          wav->getChannels() );
                wav->addSliceTransformer ( mDistortTransformer );
            }
        }

        if ( currentFinishing == _( "master flanger" ) )
        {
            if ( settingsBook->getDelayVariableCheckbox()->IsChecked() )
            {
                size_t delay = ( size_t ) settingsBook->getDelayVariableDistanceSlider()->GetValue();
                size_t feedbackLoopNo = ( size_t ) settingsBook->getDelayVariableFeedbackSlider()->GetValue();
                int lfoType = settingsBook->getDelayVariableLfoTypesBox()->GetSelection();
                double gain =  ( double ) settingsBook->getDelayVariableGainSlider()->GetValue() * 0.1;
                double lfoDepth = ( double ) settingsBook->getDelayVariableLfoDepthSlider()->GetValue() * 0.01;
                double lfoPeriodsPerSlice = ( double ) settingsBook->getDelayVariableLfoPeriodsPerSliceSlider()->GetValue() * 0.01;
                SliceTransformer<double> *mDelayVariableTransformer;
                mDelayVariableTransformer = ( SliceTransformer<double> * )
                                            new SliceDelayVariableTransformer<double> (
                                                delay,
                                                feedbackLoopNo,
                                                wav->getChannels (),
                                                lfoType,
                                                gain,
                                                lfoDepth,
                                                lfoPeriodsPerSlice );
                wav->addSliceTransformer ( mDelayVariableTransformer );
            }
        }

        if ( currentFinishing == _( "master phaser" ) )
        {
            if ( settingsBook->getDelayPhasingCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *mDelayPhaseTransformer;
                mDelayPhaseTransformer = ( SliceTransformer<double> * )
                                         new SliceDelayPhaseTransformer<double> (
                                             (( double ) settingsBook->getDelayPhasingDistanceOffsetSlider()->GetValue() )/ 22050.0,
                                             (( double ) settingsBook->getDelayPhasingDistanceRangeSlider()->GetValue() )/ 22050.0,
                                             settingsBook->getDelayPhasingLfoTypesBox()->GetSelection(),
                                             ( double ) settingsBook->getDelayPhasingLfoDepthSlider()->GetValue() * 0.01,
                                             ( double ) settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->GetValue() * 0.01,
                                             wav->getChannels(),
                                             ( double ) settingsBook->getDelayPhasingGainSlider()->GetValue() * 0.1,
                                             0 );
                wav->addSliceTransformer ( mDelayPhaseTransformer );
            }
        }

        if ( currentFinishing == _("gate") )
        {
            if ( settingsBook->getGateCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *gateTransformer;
                gateTransformer =  ( SliceTransformer<double> * )
                                   new SliceGateTransformer<double> (
                                       wav->getDataInPtr()->size(),
                                       64,
                                       wav->getChannels () );
                wav->addSliceTransformer ( gateTransformer );
            }
        }

        else if ( currentFinishing == _("pitch") )
        {
            if ( settingsBook->getPitchAdjustCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *pitchTransformer;
                pitchTransformer = ( SliceTransformer<double> * )
                                   new SlicePitchTransformer<double> (
                                       settingsBook->getPitchSemitonesSlider()->GetValue(),
                                       wav->getChannels () );
                wav->addSliceTransformer ( pitchTransformer );
            }
        }

        else if ( currentFinishing == _("normalize") )
        {
            if ( settingsBook->getNormalizeCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *normalizeTransformer;
                normalizeTransformer = ( SliceTransformer<double> * )
                                       new SliceNormalizeTransformer<double> (
                                           ( settingsBook->getNormalizeSlider()->GetValue()) * 0.01,
                                           wav->getChannels () );
                wav->addSliceTransformer ( normalizeTransformer );
            }
        }

        else if ( currentFinishing == _("declick") )
        {
            if ( settingsBook->getDeclickCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *declickTransformer;
                declickTransformer = ( SliceTransformer<double> * )
                                     new SliceDeclickTransformer<double> (
                                         wav->getChannels () );
                wav->addSliceTransformer ( declickTransformer );
            }
        }

        else if ( currentFinishing == _("enhance") )
        {
            if ( settingsBook->getEnhanceCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *enhanceTransformer;
                enhanceTransformer = ( SliceTransformer<double> * )
                                     new SliceEnhanceTransformer<double> (
                                         wav->getChannels () );
                wav->addSliceTransformer ( enhanceTransformer );
            }
        }

        else if ( currentFinishing == _("loudness") )
        {
            if ( settingsBook->getLoudnessCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *fftLoudnessTransformer;
                fftLoudnessTransformer = ( SliceTransformer<double> * )
                                         new SliceFFTTransformer<double> (
                                             FFT_BANDSTOP,
                                             ( settingsBook->getLoudnessBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getLoudnessSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getLoudnessBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                             ( settingsBook->getLoudnessSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                             wav->getChannels () );
                wav->addSliceTransformer ( fftLoudnessTransformer );
            }
        }

        else if ( currentFinishing == _("eq") )
        {
            if ( settingsBook->getEqCheckbox()->IsChecked() )
            {
                double cutoffFrequencyLow, cutoffFrequencyHigh;
                cutoffFrequencyLow = 500.0;
                cutoffFrequencyHigh = 5000.0;
                SliceTransformer<double> *eqTransformer;
                eqTransformer = ( SliceTransformer<double> * )
                                new SliceEqTransformer<double> (
                                    ( settingsBook->getEqLowGainSlider()->GetValue() ) * 0.01,
                                    ( settingsBook->getEqMidGainSlider()->GetValue() ) * 0.01,
                                    ( settingsBook->getEqHighGainSlider()->GetValue() ) * 0.01,
                                    cutoffFrequencyLow,
                                    cutoffFrequencyHigh,
                                    wav->getChannels () );
                wav->addSliceTransformer ( eqTransformer );
            }
        }


        else if ( currentFinishing == _("master reverb") )
        {
            if ( settingsBook->getReverbCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *mReverbTransformer;
                double roomsize, damp, dryMix;
                roomsize = ( settingsBook->getReverbRoomsizeSlider()->GetValue() ) / 100.0;
                damp = ( settingsBook->getReverbDampSlider()->GetValue() ) / 100.0;
                dryMix = ( settingsBook->getReverbDryMixSlider()->GetValue() ) / 100.0;
                mReverbTransformer = ( SliceTransformer<double> * )
                                     new SliceReverbTransformer<double> (
                                         roomsize,
                                         damp,
                                         dryMix,
                                         wav->getChannels () );
                wav->addSliceTransformer ( mReverbTransformer );
            }
        }

        else if ( currentFinishing == _("master aux") )
        {
            if ( settingsBook->getAuxCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *mAuxTransformer;
                mAuxTransformer = ( SliceTransformer<double> * )
                                  new SliceAuxTransformer<double> (
                                      userAuxCsdFile,
                                      wav->getChannels () );
                wav->addSliceTransformer ( mAuxTransformer );
            }
        }

        else if ( currentFinishing == _("master filter") )
        {
            if ( settingsBook->getMasterFilterCheckbox()->IsChecked() )
            {
                double resonanceMax, modulationDepth, lfoDepth;
                int modulationType, lfoType;
                size_t lfoPeriodsPerSlice = 0;
                modulationType = FFT_MOD_NONE;
                lfoType = FFT_LFO_NONE;
                resonanceMax = modulationDepth = lfoDepth = 0.0;

                if ( settingsBook->getMasterFilterResonanceCheckbox()->IsChecked() )
                    resonanceMax = settingsBook->getMasterFilterResonanceSlider()->GetValue();

                if ( settingsBook->getMasterFilterModulationCheckbox()->IsChecked() )
                {
                    modulationType = settingsBook->getMasterFilterModulationTypesBox()->GetSelection();
                    modulationDepth = settingsBook->getMasterFilterModulationDepthSlider()->GetValue() * 0.01;
                }

                if ( settingsBook->getMasterFilterLfoCheckbox()->IsChecked() )
                {
                    lfoType = settingsBook->getMasterFilterLfoTypesBox()->GetSelection(),
                              lfoDepth = settingsBook->getMasterFilterLfoDepthSlider()->GetValue() * 0.01;
                    lfoPeriodsPerSlice = settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->GetValue();
                }

                SliceTransformer<double> *fftMasterFilterTransformer;
                fftMasterFilterTransformer = ( SliceTransformer<double> * )
                                             new SliceFFTWindowedTransformer<double> (
                                                 settingsBook->getMasterFilterTypesBox()->GetSelection(),
                                                 modulationType,
                                                 lfoType,
                                                 ( settingsBook->getMasterFilterBandLoSlider()->GetValue() ) * 0.5 / 22050,
                                                 ( settingsBook->getMasterFilterSlopeLoSlider()->GetValue() ) * 0.5 / 22050,
                                                 ( settingsBook->getMasterFilterBandHiSlider()->GetValue() ) * 0.5 / 22050,
                                                 ( settingsBook->getMasterFilterSlopeHiSlider()->GetValue() ) * 0.5 / 22050,
                                                 1024,
                                                 modulationDepth,
                                                 lfoDepth,
                                                 resonanceMax,
                                                 lfoPeriodsPerSlice,
                                                 wav->getChannels () );
                wav->addSliceTransformer ( fftMasterFilterTransformer );
            }
        }

        else if ( currentFinishing == _("compress") )
        {
            if ( settingsBook->getCompressCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *compressTransformer;
                compressTransformer = ( SliceTransformer<double> * )
                                      new SliceCompressTransformer<double> (
                                          settingsBook->getCompressCutoffSlider()->GetValue() * 0.01,
                                          settingsBook->getCompressRangeSlider()->GetValue() * 0.01,
                                          wav->getChannels () );
                wav->addSliceTransformer ( compressTransformer );
            }
        }

        else if ( currentFinishing == _("match bpm") )
        {
            if ( settingsBook->getMatchBpmCheckbox()->IsChecked() )
            {
                SliceTransformer<double> *bpmTransformer;
                bpmTransformer = ( SliceTransformer<double> * )
                                 new SliceBpmTransformer<double> (
                                     settingsBook->getMatchBpmBeatsSlider()->GetValue(),
                                     settingsBook->getMatchBpmTargetBpmSlider()->GetValue(),
                                     wav->getChannels () );
                wav->addSliceTransformer ( bpmTransformer );
            }
        }
    }
}

void smasherFrame::OnBuildSong( wxCommandEvent& event )
{
    size_t songLength = settingsBook->getSongLengthSlider()->GetValue();
    bool shuffleVersesByKey = settingsBook->getSongShuffleVersesCheckbox()->IsChecked();

    bool abort = false;
    std::string message;

    Wav16Smash *verseWav = new Wav16Smash( &abort, &message );

    if ( ! DoOpen ( verseWav, fileIn ) )
    {
        delete verseWav;
        return;
    }

    SetStatusText ( _T("preparing to save song...") );
    std::vector<double> verseDataOut, verseDataOutL, verseDataOutR,
    songDataOut, songDataOutL, songDataOutR;
    std::vector<std::vector<double> > verseVector, verseVectorL, verseVectorR,
    songVector, songVectorL, songVectorR;
    bool retL, retR;
    size_t channels = verseWav->getChannels();

    std::string key;
    settingsBook->getWarpGrid()->getWarpKey ( key );

    if ( key.empty() )
        shuffleVersesByKey = false;

    std::vector<size_t> warpVector;
    mapGrid->getPositionVector ( warpVector );
    size_t warpVectorSize = warpVector.size();

    KeyMapper<char, size_t> *km = new KeyMapper<char, size_t>( key, warpVector );

    for ( size_t i = 0; i < songLength; i++ )
    {
        verseDataOut.clear();
        verseWav->getDataOut( verseDataOut );

        if ( channels == 2 )
            SampleMath::splitChannels ( &verseDataOut, &verseDataOutL, &verseDataOutR);

        if ( shuffleVersesByKey && ( i != 0 ) )
        {
            verseVector.clear();
            verseVectorL.clear();
            verseVectorR.clear();

            switch ( channels )
            {
            case 1:
                retL = verseWav->dataToSliceVectorCrossFade ( &verseDataOut, verseVectorL, warpVectorSize );
                retR = true;
                break;
            case 2:
                retL = verseWav->dataToSliceVectorCrossFade ( &verseDataOutL, verseVectorL, warpVectorSize );
                retR = verseWav->dataToSliceVectorCrossFade ( &verseDataOutR, verseVectorR, warpVectorSize );
                break;
            default:
                retL = verseWav->dataToSliceVectorCrossFade ( &verseDataOutL, verseVectorL, warpVectorSize );
                retR = verseWav->dataToSliceVectorCrossFade ( &verseDataOutR, verseVectorR, warpVectorSize );
                break;
            }

            km->unMap( warpVector );

            std::vector<std::vector<double> > tmpVectorL, tmpVectorR;
            for ( size_t k = 0; k < warpVectorSize; k++ )
            {
                tmpVectorL.push_back ( verseVectorL.at ( warpVector.at ( k ) ) );
                if ( channels == 2 )
                    tmpVectorR.push_back ( verseVectorR.at ( warpVector.at ( k ) ) );
            }
            verseVectorL = tmpVectorL;
            verseVectorR = tmpVectorR;

            // crossfade verses
            verseDataOut.clear();
            verseDataOutL.clear();
            verseDataOutR.clear();
            switch ( channels )
            {
            case 1:
                retL = verseWav->sliceVectorToDataCrossFade( verseVectorL, &verseDataOut );
                retR = true;
                break;
            case 2:
                retL = verseWav->sliceVectorToDataCrossFade( verseVectorL, &verseDataOutL );
                retR = verseWav->sliceVectorToDataCrossFade( verseVectorR, &verseDataOutR );
                break;
            default:
                retL = verseWav->sliceVectorToDataCrossFade( verseVectorL, &verseDataOutL );
                retR = verseWav->sliceVectorToDataCrossFade( verseVectorR, &verseDataOutR );
                break;
            }
        }

        switch ( channels )
        {
        case 1:
            songVectorL.push_back ( verseDataOut );
            break;
        case 2:
            songVectorL.push_back ( verseDataOutL );
            songVectorR.push_back ( verseDataOutR );
            break;
        default:
            songVectorL.push_back ( verseDataOutL );
            songVectorR.push_back ( verseDataOutR );
            break;
        }
    }

    // crossfade verses to song
    switch ( channels )
    {
    case 1:
        retL = verseWav->sliceVectorToDataCrossFade( songVectorL, &songDataOut );
        retR = true;
        break;
    case 2:
        retL = verseWav->sliceVectorToDataCrossFade( songVectorL, &songDataOutL );
        retR = verseWav->sliceVectorToDataCrossFade( songVectorR, &songDataOutR );
        break;
    default:
        retL = verseWav->sliceVectorToDataCrossFade( songVectorL, &songDataOutL );
        retR = verseWav->sliceVectorToDataCrossFade( songVectorR, &songDataOutR );
        break;
    }

    //joinchannels
    if ( channels == 2 )
        SampleMath::joinChannels ( &songDataOutL, &songDataOutR, &songDataOut );

    SetStatusText ( _T("") );

    wxString drive, directory;
    wxFileName::SplitPath ( fileIn, &drive, &directory, NULL, NULL );
    directory =
#ifdef __WXMSW__
        drive + _T(":") +
#endif
        directory;

    std::auto_ptr<wxFileDialog> fd ( new wxFileDialog (
                                         this,
                                         _ ( "Save Song" ),
                                         directory,
                                         wxEmptyString,
#ifdef __WXMSW__
                                         _T("All files (*.*)|*.*|WAV files (*.wav)|*.wav")
#else
                                         _T("All files (*.*)|*|WAV files (*.wav)|*.wav")
#endif
                                         , wxSAVE | wxOVERWRITE_PROMPT ) );
    if ( fd->ShowModal() != wxID_OK )
    {
        delete verseWav;
        delete km;
        return;
    }

    wxString path = fd->GetPath();

    int index = fd->GetFilterIndex();
    wxString filter;
    switch ( index )
    {
    case 0:
    case 1:
        filter = _T(".wav");
        break;
    default:
        filter = _T(".wav");
        break;
    }

    if ( ! path.Lower().Contains ( filter ) )
        path.Append ( filter );

    std::string stdPath = ( const char * )path.mb_str ( wxConvUTF8 );
    if ( !verseWav->writeRawData ( (char *) stdPath.c_str(), songDataOut ) )
        SetStatusText ( _T("can't save ") + path );
    delete verseWav;
    delete km;
}

void smasherFrame::OnCheckForUpdates( wxCommandEvent& event )
{
    wxString address = _T( "http://smasher.sourceforge.net/version" );

    wxURL url ( address );

    if ( url.GetError() != wxURL_NOERR )
    {
        wxMessageBox ( _T("check internet connection"),
                       _T("can't check for updates"),
                       wxOK,
                       this  );
        return;
    }

    wxYield();
    url.GetProtocol().SetTimeout ( 5 );

    wxInputStream *inStream;

    inStream = url.GetInputStream();
    if ( !inStream )
    {
        wxMessageBox ( _T("check internet connection"),
                       _T("can't check for updates"),
                       wxOK,
                       this  );
        return;
    }

    wxString versionString;
    int i = 0;
    while ( !inStream->Eof() )
    {
        versionString.Append ( inStream->GetC() );
        if ( ++i == 4)
            break;
    }

    if ( versionString.size() != 4 )
    {
        wxMessageBox ( _T("unexpected file format"),
                       _T("can't check for updates"),
                       wxOK,
                       this );
        return;
    }

    wxString title, message, urlLabel, urlString;
    bool showUrl = false;
    if ( versionString > SMASHER_VERSION )
    {
        title = _T("update available");
        urlString = SMASHER_DOWNLOAD_URL;
        urlLabel.Printf ( _T("download version %c.%c.%c from http://sourceforge.net"), versionString[0], versionString[1], versionString[2] );
        showUrl = true;
    }
    else
    {
        title = _("no update available");
        message = _("the currently installed version is already the latest version");
    }

    UpdateDialog ud ( this, title, message, urlLabel, urlString);
    ud.ShowModal();
}

wxString smasherFrame::saveState ( )
{
    wxString s;
    s += _T("fileIn=");
    s += fileIn;
    s += _T("|sliceNo=");
    s << sliceNoSpinControl->GetValue();
    s += _T("|mapGrid=");
    s += mapGrid->saveState();

    wxString name, posVectorString;
    std::vector<size_t> positionVector;
    size_t effectsVectorSize = effectsVector.size();
    size_t sliceCount = mapGrid->GetNumberCols();
    std::set<size_t> positionLookup;

    for ( size_t i = 0; i < effectsVectorSize; i++ )
    {
        name = effectsVector.at ( i );
        effectsGrid->getNamedPositionVector ( name, positionVector );
        std::vector<size_t>::iterator it;
        for ( it = positionVector.begin(); it != positionVector.end(); it++ )
            positionLookup.insert ( *it );

        for ( size_t j = 0; j < sliceCount; j++ )
        {
            if ( positionLookup.count ( j ) != 0 )
                posVectorString += _T("1");
            else
                posVectorString += _T("0");
        }

        s += _T("|");
        s += name;
        s += _T("=");
        s += posVectorString;
        posVectorString.clear();
        positionVector.clear();
        positionLookup.clear();
    }

    s += _T("|effectsChainBox=");
    s += settingsBook->getEffectsChainBox()->saveState();
    s += _T("|finishingChainBox=");
    s += settingsBook->getFinishingChainBox()->saveState();
    s += _T("|tremoloDepth=");
    s << settingsBook->getTremoloDepthSlider()->GetValue();
    s += _T("|tremoloPeriodsPerSlice=");
    s << settingsBook->getTremoloPeriodsPerSliceSlider()->GetValue();
    s += _T("|tremoloType=");
    s << settingsBook->getTremoloTypesBox()->GetSelection();
    s += _T("|tremoloStereoMode=");
    s << settingsBook->getTremoloStereoModeBox()->GetSelection();
    s += _T("|fadeInRange=");
    s << settingsBook->getFadeInRangeSlider()->GetValue();
    s += _T("|fadeInType=");
    s << settingsBook->getFadeInTypesBox()->GetSelection();
    s += _T("|fadeOutRange=");
    s << settingsBook->getFadeOutRangeSlider()->GetValue();
    s += _T("|fadeOutType=");
    s << settingsBook->getFadeOutTypesBox()->GetSelection();
    s += _T("|delayMultiTapDistance=");
    s << settingsBook->getDelayMultiTapDistanceSlider()->GetValue();
    s += _T("|delayMultiTapStepNo=");
    s << settingsBook->getDelayMultiTapStepNoSlider()->GetValue();
    s += _T("|delayMultiTapGain=");
    s << settingsBook->getDelayMultiTapGainSlider()->GetValue();
    s += _T("|delayMultiTapFeedback=");
    s << settingsBook->getDelayMultiTapFeedbackSlider()->GetValue();
    s += _T("|delayVariableDistance=");
    s << settingsBook->getDelayVariableDistanceSlider()->GetValue();
    s += _T("|delayVariableGain=");
    s << settingsBook->getDelayVariableGainSlider()->GetValue();
    s += _T("|delayVariableFeedback=");
    s << settingsBook->getDelayVariableFeedbackSlider()->GetValue();
    s += _T("|delayVariableLfoTypesBox=");
    s << settingsBook->getDelayVariableLfoTypesBox()->GetSelection();
    s += _T("|delayVariableLfoDepth=");
    s << settingsBook->getDelayVariableLfoDepthSlider()->GetValue();
    s += _T("|delayVariableLfoPeriodsPerSlice=");
    s << settingsBook->getDelayVariableLfoPeriodsPerSliceSlider()->GetValue();
    s += _T ( "|delayVariableCheckbox=" );
    s << settingsBook->getDelayVariableCheckbox()->IsChecked();
    s += _T("|delayPhasingDistanceOffset=");
    s << settingsBook->getDelayPhasingDistanceOffsetSlider()->GetValue();
    s += _T("|delayPhasingDistanceRangeSlider=");
    s << settingsBook->getDelayPhasingDistanceRangeSlider()->GetValue();
    s += _T("|delayPhasingGainSlider=");
    s << settingsBook->getDelayPhasingGainSlider()->GetValue();
    s += _T("|delayPhasingLfoTypesBox=");
    s << settingsBook->getDelayPhasingLfoTypesBox()->GetSelection();
    s += _T("|delayPhasingLfoDepthSlider=");
    s << settingsBook->getDelayPhasingLfoDepthSlider()->GetValue();
    s += _T("|delayPhasingLfoPeriodsPerSliceSlider=");
    s << settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->GetValue();
    s += _T("|delayPhasingDistanceOffsetSlider=");
    s << settingsBook->getDelayPhasingDistanceOffsetSlider()->GetValue();
    s += _T("|delayPhasingDistanceRangeSlider=");
    s << settingsBook->getDelayPhasingDistanceRangeSlider()->GetValue();
    s += _T("|delayPhasingGainSlider=");
    s << settingsBook->getDelayPhasingGainSlider()->GetValue();
    s += _T("|delayPhasingLfoTypesBox=");
    s << settingsBook->getDelayPhasingLfoTypesBox()->GetSelection();
    s += _T("|delayPhasingLfoDepthSlider=");
    s << settingsBook->getDelayPhasingLfoDepthSlider()->GetValue();
    s += _T("|delayPhasingLfoPeriodsPerSliceSlider=");
    s << settingsBook->getDelayPhasingLfoPeriodsPerSliceSlider()->GetValue();
    s += _T ( "|delayPhasingCheckbox=" );
    s << settingsBook->getDelayPhasingCheckbox()->IsChecked();
    s += _T("|masterDistortPregain=");
    s << settingsBook->getDistortPregainSlider()->GetValue();
    s += _T("|masterDistortPostgain=");
    s << settingsBook->getDistortPostgainSlider()->GetValue();
    s += _T("|masterDistortCutoff=");
    s << settingsBook->getDistortCutoffSlider()->GetValue();
    s += _T("|distortFeedback=");
    s << settingsBook->getDistortFeedbackSlider()->GetValue();
    s += _T("|distortToneShaping1=");
    s << settingsBook->getDistortToneShaping1Slider()->GetValue();
    s += _T("|distortToneShaping2=");
    s << settingsBook->getDistortToneShaping2Slider()->GetValue();
    s += _T("|masterDistortCheckbox=");
    s << settingsBook->getDistortCheckbox()->IsChecked();
    s += _T("|bitCrusherType=");
    s << settingsBook->getBitCrushTypesBox()->GetSelection();
    s += _T("|downSampleType=");
    s << settingsBook->getDownSampleTypesBox()->GetSelection();
    s += _T("|pitchSemitones=");
    s << settingsBook->getPitchSemitonesSlider()->GetValue();
    s += _T("|pitchAdjust=");
    s << settingsBook->getPitchAdjustCheckbox()->IsChecked();
    s += _T("|normalizeTo=");
    s << settingsBook->getNormalizeSlider()->GetValue();
    s += _T("|normalize=");
    s << settingsBook->getNormalizeCheckbox()->IsChecked();
    s += _T("|compressCutoff=");
    s << settingsBook->getCompressCutoffSlider()->GetValue();
    s += _T("|compressRange=");
    s << settingsBook->getCompressRangeSlider()->GetValue();
    s += _T("|compress=");
    s << settingsBook->getCompressCheckbox()->IsChecked();
    s += _T("|gate=");
    s << settingsBook->getGateCheckbox()->IsChecked();
    s += _T("|LPBandHi=");
    s << settingsBook->getFftLowPassBandHiSlider()->GetValue();
    s += _T("|LPSlopeHi=");
    s << settingsBook->getFftLowPassSlopeHiSlider()->GetValue();
    s += _T("|HPBandLo=");
    s << settingsBook->getFftHighPassBandLoSlider()->GetValue();
    s += _T("|HPSlopeLo=");
    s << settingsBook->getFftHighPassSlopeLoSlider()->GetValue();
    s += _T("|BPBandLo=");
    s << settingsBook->getFftBandPassBandLoSlider()->GetValue();
    s += _T("|BPSlopeLo=");
    s << settingsBook->getFftBandPassSlopeLoSlider()->GetValue();
    s += _T("|BPBandHi=");
    s << settingsBook->getFftBandPassBandHiSlider()->GetValue();
    s += _T("|BPSlopeHi=");
    s << settingsBook->getFftBandPassSlopeHiSlider()->GetValue();
    s += _T("|BSBandLo=");
    s << settingsBook->getFftBandStopBandLoSlider()->GetValue();
    s += _T("|BSSlopeLo=");
    s << settingsBook->getFftBandStopSlopeLoSlider()->GetValue();
    s += _T("|BSBandHi=");
    s << settingsBook->getFftBandStopBandHiSlider()->GetValue();
    s += _T("|BSSlopeHi=");
    s << settingsBook->getFftBandStopSlopeHiSlider()->GetValue();
    s += _T("|LoudBandLo=");
    s << settingsBook->getLoudnessBandLoSlider()->GetValue();
    s += _T("|LoudBandHi=");
    s << settingsBook->getLoudnessBandHiSlider()->GetValue();
    s += _T("|LoudSlopeHi=");
    s << settingsBook->getLoudnessSlopeHiSlider()->GetValue();
    s += _T("|LoudCheckbox=");
    s << settingsBook->getLoudnessCheckbox()->IsChecked();
    s += _T("|MasterFilterTypesBox=");
    s << settingsBook->getMasterFilterTypesBox()->GetSelection();
    s += _T("|MasterFilterBandLoSlider=");
    s << settingsBook->getMasterFilterBandLoSlider()->GetValue();
    s += _T("|MasterFilterSlopeLoSlider=");
    s << settingsBook->getMasterFilterSlopeLoSlider()->GetValue();
    s += _T("|MasterFilterBandHiSlider=");
    s << settingsBook->getMasterFilterBandHiSlider()->GetValue();
    s += _T("|MasterFilterSlopeHiSlider=");
    s << settingsBook->getMasterFilterSlopeHiSlider()->GetValue();
    s += _T("|MasterFilterCheckbox=");
    s << settingsBook->getMasterFilterCheckbox()->IsChecked();
    s += _T("|MasterFilterModulationTypesBox=");
    s << settingsBook->getMasterFilterModulationTypesBox()->GetSelection();
    s += _T("|MasterFilterModulationDepthSlider=");
    s << settingsBook->getMasterFilterModulationDepthSlider()->GetValue();
    s += _T("|MasterFilterLfoTypesBox=");
    s << settingsBook->getMasterFilterLfoTypesBox()->GetSelection();
    s += _T("|MasterFilterLfoDepthSlider=");
    s << settingsBook->getMasterFilterLfoDepthSlider()->GetValue();
    s += _T("|MasterFilterLfoPeriodsPerSliceSlider=");
    s << settingsBook->getMasterFilterLfoPeriodsPerSliceSlider()->GetValue();
    s += _T("|MasterFilterLfoCheckbox=");
    s << settingsBook->getMasterFilterLfoCheckbox()->IsChecked();
    s += _T("|MasterFilterModulationCheckbox=");
    s << settingsBook->getMasterFilterModulationCheckbox()->IsChecked();
    s += _T("|MasterFilterResonanceCheckbox=");
    s << settingsBook->getMasterFilterResonanceCheckbox()->IsChecked();
    s += _T("|MasterFilterResonanceSlider=");
    s << settingsBook->getMasterFilterResonanceSlider()->GetValue();
    s += _T("|retriggerCountSlider=");
    s << settingsBook->getRetriggerCountSlider()->GetValue();
    s += _T( "|reverbRoomsizeSlider=" );
    s << settingsBook->getReverbRoomsizeSlider()->GetValue();
    s += _T( "|reverbDampSlider=" );
    s << settingsBook->getReverbDampSlider()->GetValue();
    s += _T( "|reverbDryMixSlider=" );
    s << settingsBook->getReverbDryMixSlider()->GetValue();
    s += _T( "|reverbCheckbox=" );
    s << settingsBook->getReverbCheckbox()->IsChecked();
    s += _T( "|auxCheckbox=" );
    s << settingsBook->getAuxCheckbox()->IsChecked();
    s += _T( "|matchBpmBeatsSlider=" );
    s << settingsBook->getMatchBpmBeatsSlider()->GetValue();
    s += _T ( "|matchBpmTargetBpmSlider=" );
    s << settingsBook->getMatchBpmTargetBpmSlider()->GetValue();
    s += _T ( "|matchBpmCheckbox=" );
    s << settingsBook->getMatchBpmCheckbox()->IsChecked();
    s += _T ( "|eqCheckbox=" );
    s << settingsBook->getEqCheckbox()->IsChecked();
    s += _T ( "|eqLowGainSlider=" );
    s << settingsBook->getEqLowGainSlider()->GetValue();
    s += _T ( "|eqMidGainSlider=" );
    s << settingsBook->getEqMidGainSlider()->GetValue();
    s += _T ( "|eqHighGainSlider=" );
    s << settingsBook->getEqHighGainSlider()->GetValue();
    s += _T ( "|declickCheckbox=" );
    s << settingsBook->getDeclickCheckbox()->IsChecked();
    s += _T ( "|enhanceCheckbox=" );
    s << settingsBook->getEnhanceCheckbox()->IsChecked();
    return s;
}

void smasherFrame::swapMediaCtrls ()
{
    alternativeCtrlIsCurrentCtrl = !alternativeCtrlIsCurrentCtrl;
}

wxMediaCtrl *smasherFrame::getAlternativeMediaCtrl()
{
    if ( alternativeCtrlIsCurrentCtrl )
    {
        return mediaCtrl;
    }
    return mediaCtrlAlt;
}

wxMediaCtrl *smasherFrame::getCurrentMediaCtrl()
{
    if ( alternativeCtrlIsCurrentCtrl )
    {
        return mediaCtrlAlt;
    }
    return mediaCtrl;

}

MediaTimer *smasherFrame::getCurrentMediaTimer()
{
    return ( alternativeCtrlIsCurrentCtrl ) ? mediaTimerAlt : mediaTimer;
}

void smasherFrame::startLoopTimer()
{
    loopTimer->Start ( getCurrentMediaCtrl()->Length() - loopLatency, true );
}

void smasherFrame::updateFileMenu ( bool deleteExisting )
{
    if ( deleteExisting )
    {
        wxMenuItemList list = fileMenu->GetMenuItems();
        size_t count = list.size();
        for ( size_t i = 0; i < count; i++ )
            fileMenu->Delete ( list[i] );
    }
    fileMenu->Append(ID_OPEN, _("&open...\tCtrl+O"), _("open"));
    fileMenu->Append(ID_SAVE, _("&save as...\tCtrl+S"), _("save as"));
    fileMenu->Append(ID_SAVE_SONG, _("s&ave song...\tCtrl+Shift+S"), _("save song"));
    fileMenu->Append(ID_LOAD_MACHINE_STATE, _("&load machine state...\tCtrl+Alt+O"), _("load machine state"));
    fileMenu->Append(ID_SAVE_MACHINE_STATE, _("sa&ve machine state...\tCtrl+Alt+S"), _("save machine state"));
    fileMenu->Append(ID_SHARE, _("s&hare preset\tCtrl+H"), _("share preset"));
    fileMenu->Append(ID_RESTORE_DEFAULT, _("&restore preset\tCtrl+R"), _("restore preset"));
    fileMenu->Append(wxID_EXIT, _("&quit\tAlt-F4"), _("quit"));

    fileHistory.AddFilesToMenu ( fileMenu );
}

void smasherFrame::updatePlotArea ()
{
    smasherCriticalSectionLocker lock ( &criticalSection, &csRefCounter );

    if ( !pathValid )
    {
        //std::cout << "updatePlotArea - !pathValid" << std::endl;
        return;
    }

    if ( w->getState() != WAV16_HAS_DATA_OUT )
    {
        //std::cout << "updatePlotArea - w->getState() != WAV16_HAS_DATA_OUT" << std::endl;
        return;
    }

    if ( !lPlot || !rPlot )
    {
        //std::cout << "updatePlotArea - !lPlot || !rPlot" << std::endl;
        return;
    }

    manager->GetPane ( rPlot ).Show ( ( w->getChannels() == 2 ) );
    manager->Update();

    std::vector<double> *data = w->getDataOutPtr();

    size_t dataSize = data->size();
    size_t channelSize = dataSize / w->getChannels();
    double numberCols;
    numberCols = (double) ( mapGrid->GetNumberCols() );
    int plotPixelNo;
    plotPixelNo = (int) ( 16.0/9.0 * 16.0 * numberCols );

    if ( !plotPixelNo )
    {
        //std::cout << "updatePlotArea - !plotPixelNo" << std::endl;
        return;
    }

    size_t window = channelSize / plotPixelNo;

    if ( ( dataSize < 1 ) || !window )
    {
        //std::cout << "updatePlotArea -  ( dataSize < 1 ) || !window " << std::endl;
        return;
    }

    size_t i, j, channels;
    double lCurrentSample, rCurrentSample;
    double maxLCurrentSample, maxRCurrentSample;
    maxLCurrentSample = maxRCurrentSample = 0.0;

    lPlotData.clear();

    channels = w->getChannels();
    for ( i = 0, j = 0 ; i < dataSize - 1; i += channels, j++ )
    {
        lCurrentSample = fabs ( data->at ( i ) );

        if ( lCurrentSample > DOUBLE_SHRT_MAX )
            lCurrentSample = 1.0;
        else
            lCurrentSample /= DOUBLE_SHRT_MAX;
        maxLCurrentSample = ( lCurrentSample > maxLCurrentSample ) ? lCurrentSample : maxLCurrentSample;

        if ( j == window )
        {
            lPlotData.push_back ( maxLCurrentSample );
            maxLCurrentSample = 0.0;
            j = 0;
        }
    }

    lPlot->set ( &lPlotData );

    if ( channels == 1 )
    {
        if ( lPlotData.empty() )
            ;//std::cout << "updatePlotArea: lPlotData.empty()" << std::endl;

        return;
    }

    rPlotData.clear();
    for ( i = 1, j = 0 ; i < dataSize; i += channels, j++ )
    {
        rCurrentSample = fabs ( data->at ( i ) );

        if ( rCurrentSample > DOUBLE_SHRT_MAX )
            rCurrentSample = 1.0;
        else
            rCurrentSample /= DOUBLE_SHRT_MAX;
        maxRCurrentSample = ( rCurrentSample > maxRCurrentSample ) ? rCurrentSample : maxRCurrentSample;

        if ( j == window )
        {
            rPlotData.push_back ( maxRCurrentSample );
            maxRCurrentSample = 0.0;
            j = 0;
        }
    }
    rPlot->set ( &rPlotData );

    if ( rPlotData.empty() )
    {
        //std::cout << "updatePlotArea: lPlotData.empty() || rPlotData.empty()" << std::endl;
        return;
    }

}

void smasherFrame::notifyPlaybackTime()
{
    if ( closeDown || slicePlayState )
        return;

    wxLongLong llTell = getCurrentMediaCtrl()->Tell();
    int nMinutes = (int) (llTell / 60000).GetValue();
    int nSeconds = (int) ((llTell % 60000)/1000).GetValue();

    wxLongLong llLength = getCurrentMediaCtrl()->Length();
    int nMinutesTotal = (int) (llLength / 60000).GetValue();
    int nSecondsTotal = (int) ((llLength % 60000)/1000).GetValue();

    int colNo = mapGrid->GetNumberCols();


    long long denom = llLength.GetValue();
    int gridColumn = ( denom ) ? ( colNo * llTell.GetValue() ) / denom : 0;

    if ( llTell.GetValue() != 0 &&
            gridColumn != gridColumnMemory &&
            gridColumn < colNo &&
            manager->GetPane ( progressGrid ).IsShown() )
    {
        gridColumnMemory = gridColumn;
        progressGrid->setColumn ( gridColumn );
    }

    if ( !nMinutesTotal && !nSecondsTotal )
    {
        SetStatusText ( wxEmptyString, STATUS_TIMER );
        return;
    }
    wxString sPosition, oldPosition;
    sPosition.Printf( _T(" %i:%02i / %i:%02i"), nMinutes, nSeconds, nMinutesTotal, nSecondsTotal );
    oldPosition = GetStatusBar()->GetStatusText ( STATUS_TIMER );

    if ( oldPosition == sPosition )
        return;

    SetStatusText ( sPosition, STATUS_TIMER );
}


void smasherFrame::updateTitle ( const wxString& s )
{
    wxString name, extension, extensionSeparator;
    wxFileName::SplitPath ( s, NULL, NULL, &name, &extension );
    extensionSeparator = ( extension.empty() ) ? wxEmptyString : _T(".");
    name.Replace ( _T("_"), _T(" ") );
    SetTitle (
        name +
        extensionSeparator +
        extension +
        _(" - smasher" ) );
}

void smasherFrame::setLoopLatency ( int i )
{
    loopLatency = i;
}

void smasherFrame::OnPaneClose( wxAuiManagerEvent& event )
{
    wxString paneName = event.pane->name;

    if ( paneName == _T( "settingsBook" ) )
        DoShowSettings();
    else if ( paneName == _T( "helpPane" ) )
        DoShowHelp();

    event.Veto();
}

void smasherFrame::OnTimer ( wxTimerEvent& e )
{
    DoIdle();
}

wxAuiManager *smasherFrame::getManager()
{
    return manager;
}

bool smasherFrame::getViewSettingsState()
{
    return viewSettingsState;
}

bool smasherFrame::getChangedWhilePlaying()
{
    return changedWhilePlaying;
}

void smasherFrame::setChangedWhilePlaying ( bool b )
{
    changedWhilePlaying = b;
}

void smasherFrame::activateFactoryPreset ( int index, bool newData )
{
    wxString shortFileName, fileName;
    shortFileName = settingsBook->getFactoryListView ( )->GetItemText ( index );

    std::map<wxString, wxString> filesMap;
    settingsBook->getFilesMap ( filesMap );

    fileName = filesMap[shortFileName];
    try
    {
        BinaryFile bf ( (const char *)fileName.mb_str ( wxConvLocal ) );
        wxString buffer = wxString ( bf.getData(), wxConvUTF8, bf.getDataLen() );
        loadState ( buffer, newData );
    }
    catch ( ... )
        { }
    settingsBook->getFactoryListView()->Select( index );

}

void smasherFrame::prepareDataDir()
{
    wxString dataDir, csdDir, auxFile, mainAuxCsdFile;
    dataDir = Dir::getDataDir();
    csdDir = Dir::getCsdDir();
    auxFile = _T("smasher_fx_aux.csd");
    mainAuxCsdFile = csdDir + auxFile;
    userAuxCsdFile = dataDir + auxFile;


    if ( wxFileName::FileExists( userAuxCsdFile ) ||
            !wxFileName::FileExists ( mainAuxCsdFile ) )
        return;

    wxCopyFile ( mainAuxCsdFile, userAuxCsdFile );
}
