#ifndef SMASHGRIDMAPPER_H
#define SMASHGRIDMAPPER_H

#include <vector>
#include <algorithm>
#include "smashmapper.h"

template<class T>
class SmashGridMapper : public SmashMapper<T>
{
public:
    SmashGridMapper ( std::vector<size_t> &positionVector );
    virtual ~SmashGridMapper() { }
    void map ( std::vector<T>& resultVector );
private:
    std::vector<size_t> positionVector;
};

template<class T>
SmashGridMapper<T>::SmashGridMapper( std::vector<size_t> &positionVectorParameter ) :
        positionVector ( positionVectorParameter ) { }

template<class T>
void SmashGridMapper<T>::map( std::vector<T>& resultVector )
{
    std::vector<T> tmp;
    size_t mappedPos;
    for ( size_t i = 0; i < resultVector.size(); i++)
    {
        mappedPos = positionVector.at ( i );
        if ( mappedPos == UINT_MAX )
        {
            T tmpSlice;
            size_t tmpSliceLength = resultVector.at ( 0 ).size ();
            if ( tmpSliceLength % 2 )
                tmpSliceLength ++;
            for ( size_t j = 0; j < tmpSliceLength; j++ )
            {
                tmpSlice.push_back ( 0.0 );
            }
            tmp.push_back ( tmpSlice );
        }
        else
        {
            tmp.push_back ( resultVector.at ( mappedPos ) );
        }
    }
    resultVector = tmp;
}

#endif

