#ifndef SMASHKEYMAPPER_H
#define SMASHKEYMAPPER_H

#include <vector>
#include <string>
#include "smashmapper.h"
#include "keymapper.h"

template<class T>
class SmashKeyMapper : public SmashMapper<T>
{
public:
    SmashKeyMapper ( std::string keyParameter );
    void map ( std::vector<T>& resultVector );
private:
    std::string key;
};

template<class T>
SmashKeyMapper<T>::SmashKeyMapper( std::string keyParameter )
{
    key = keyParameter;
}

template<class T>
void SmashKeyMapper<T>::map( std::vector<T>& resultVector )
{
    KeyMapper<char,T> km ( key, resultVector );
    km.map ( resultVector );
}

#endif
