#ifndef SMASHSORTMAPPER_H
#define SMASHSORTMAPPER_H

#include <vector>
#include <algorithm>
#include "smashmapper.h"

enum {SORT_ASCENDING, SORT_DESCENDING};

template<class T>
class SmashSortMapper : public SmashMapper<T>
{
public:
    SmashSortMapper ( int sortFlagParameter = SORT_ASCENDING );
    void map ( std::vector<T>& resultVector );
private:
    int sortFlag;
};

template<class T>
SmashSortMapper<T>::SmashSortMapper( int sortFlagParameter )
{
    sortFlag = sortFlagParameter;
}

template<class T>
void SmashSortMapper<T>::map( std::vector<T>& resultVector )
{
    if (sortFlag == SORT_ASCENDING)
        std::sort ( resultVector.begin(), resultVector.end() );
    else if (sortFlag == SORT_DESCENDING)
        std::sort ( resultVector.begin(), resultVector.end() ); //tbd
}

#endif
