#include "smashthread.h"
#include <wx/wx.h>

SmashThread::SmashThread (
    Wav16Smash *w,
    int *state,
    std::string *message,
    int sliceNo ) : wxThread(),
        myW ( w ),
        myStatePtr ( state ),
        myMessagePtr ( message ),
        mySliceNo ( sliceNo )
{

}

void *SmashThread::Entry()
{
    if ( *myStatePtr == SMASH_THREAD_ERROR || TestDestroy() )
    {
        Exit();
        return NULL;
    }

    bool res = myW->smash( mySliceNo );

    if ( *myStatePtr == SMASH_THREAD_ERROR || TestDestroy() )
    {
        Exit();
        return NULL;
    }

    *myStatePtr = SMASH_THREAD_FINISHED;
    if ( !res )
    {
        *myStatePtr = SMASH_THREAD_FINISHED;
        Exit();
        return NULL;
    }

    Exit();

    return NULL;
}

void SmashThread::OnExit()
{
    *myStatePtr = SMASH_THREAD_FINISHED;
}

