#include "updatedialog.h"
#include <wx/stattext.h>
#include <wx/button.h>
#include <wx/hyperlink.h>
#include <wx/sizer.h>

BEGIN_EVENT_TABLE ( UpdateDialog, wxDialog )
    EVT_BUTTON ( wxID_CANCEL, UpdateDialog::OnOk )
END_EVENT_TABLE()

UpdateDialog::UpdateDialog (
    wxWindow *parent,
    const wxString& title,
    const wxString& message,
    const wxString& urlLabel,
    const wxString& url ) :
        wxDialog ( parent, wxID_ANY, title )
{
    wxBoxSizer *sizer = new wxBoxSizer ( wxVERTICAL );

    sizer->AddSpacer ( 5 );
    if ( !message.empty() )
    {
        staticText = new wxStaticText ( this, wxID_ANY, message );
        sizer->Add ( staticText, 0, wxTOP | wxLEFT | wxRIGHT | wxBOTTOM, 5 );
    }
    else if ( !url.empty() )
    {
        hyperlink = new wxHyperlinkCtrl ( this, wxID_ANY, urlLabel, url );
        sizer->Add ( hyperlink, 0, wxTOP | wxLEFT | wxRIGHT | wxBOTTOM, 5 );
    }

    button = new wxButton ( this, wxID_CANCEL, _("OK") );
    sizer->Add ( button, 0, wxTOP | wxLEFT | wxRIGHT | wxBOTTOM | wxALIGN_RIGHT, 5 );

    SetSizer ( sizer );
    sizer->Fit ( this );
    button->SetFocus();
}

UpdateDialog::~UpdateDialog()
{ }


void UpdateDialog::OnOk ( wxCommandEvent& e )
{
    e.Skip();
}

