#ifndef URLPROVIDER_H
#define URLPROVIDER_H

#include <string>

class UrlProvider
{
public:
    UrlProvider();
    std::string getShareUrl();
    std::string getRateUrl();
    std::string getRefreshUrl();
    std::string getRegisterUrl();
    std::string getPasscodeUrl();
    std::string getDownloadUrl();
private:
    enum urlTypes {
        URL_SHARE,
        URL_REFRESH,
        URL_REGISTER,
        URL_PASSCODE,
        URL_DOWNLOAD,
        URL_RATE
    };
    std::string getUrl ( int urlType );
    void unscramble( const std::string& scrambledUrl, const std::string& key, std::string& url );
};

#endif
