#include <algorithm>
#include <cstdlib>
#include <map>

#include <wx/window.h>

#include "warpgrid.h"

size_t pattern2_1Array[] = { 1, 0 };

size_t pattern4_1Array[] = { 3, 2, 1, 0 };
size_t pattern4_2Array[] = { 3, 0, 2, 1 };
size_t pattern4_3Array[] = { 0, 2, 1, 3 };
size_t pattern4_4Array[] = { 2, 3, 1, 0 };
size_t pattern4_5Array[] = { 3, 1, 2, 0 };
size_t pattern4_6Array[] = { 2, 3, 0, 1 };
size_t pattern4_7Array[] = { 1, 2, 0, 3 };
size_t pattern4_8Array[] = { 2, 0, 3, 1 };

size_t pattern8_1Array[] = { 7, 6, 5, 4, 3, 2, 1, 0 };
size_t pattern8_2Array[] = { 7, 6, 2, 3, 4, 5, 1, 0 };
size_t pattern8_3Array[] = { 0, 7, 1, 6, 2, 5, 3, 4 };
size_t pattern8_4Array[] = { 3, 4, 2, 5, 1, 6, 0, 7 };
size_t pattern8_5Array[] = { 0, 1, 5, 4, 3, 2, 6, 7 };
size_t pattern8_6Array[] = { 4, 5, 6, 7, 0, 1, 2, 3 };
size_t pattern8_7Array[] = { 4, 5, 6, 7, 3, 2, 1, 0 };
size_t pattern8_8Array[] = { 4, 2, 7, 0, 3, 6, 1, 5 };

size_t pattern16_1Array[] = { 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0 };
size_t pattern16_2Array[] = { 0, 6, 13, 3, 8, 9, 2, 5, 1, 11, 14, 4, 15, 12, 7, 10 };
size_t pattern16_3Array[] = { 0, 15, 1, 14, 2, 13, 3, 12, 4, 11, 5, 10, 6, 9, 7, 8 };
size_t pattern16_4Array[] = { 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15, 0 };
size_t pattern16_5Array[] = { 8, 9, 10, 11, 12, 13, 14, 15, 0, 1, 2, 3, 4, 5, 6, 7 };
size_t pattern16_6Array[] = { 8, 9, 10, 11, 12, 13, 14, 15, 7, 6, 5, 4, 3, 2, 1, 0 };
size_t pattern16_7Array[] = { 0, 1, 2, 3, 4, 11, 10, 9, 8, 7, 6, 5, 12, 13, 14, 15 };
size_t pattern16_8Array[] = { 15, 14, 13, 12, 5, 6, 7, 8, 9, 10, 11, 4, 3, 2, 1, 0 };


WarpGrid::WarpGrid (
    wxWindow *parent,
    int id,
    size_t rowNo,
    size_t colNo,
    int cellHeight,
    int cellWidth,
    bool verticalConstraint ) :
        MonochromeGrid ( parent, id, rowNo, colNo,
                         cellHeight, cellWidth, verticalConstraint )
{
    SetColLabelSize ( 0 );
    SetRowLabelSize ( 0 );

    SetDefaultRowSize ( cellHeight, true );
    SetDefaultColSize ( cellWidth, true );

    patternArrayVector.clear();

    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern2_1Array, sizeof(pattern2_1Array)/sizeof(size_t) ),
            _( "invert 2x2" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_1Array, sizeof(pattern4_1Array)/sizeof(size_t) ),
            _( "invert 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_1Array, sizeof(pattern8_1Array)/sizeof(size_t) ),
            _( "invert 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_1Array, sizeof(pattern16_1Array)/sizeof(size_t) ),
            _( "invert 16x16" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_2Array, sizeof(pattern4_2Array)/sizeof(size_t) ),
            _( "glide east 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_3Array, sizeof(pattern8_3Array)/sizeof(size_t) ),
            _( "glide east 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_3Array, sizeof(pattern16_3Array)/sizeof(size_t) ),
            _( "glide east 16x16" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_7Array, sizeof(pattern4_7Array)/sizeof(size_t) ),
            _( "glide west 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_4Array, sizeof(pattern8_4Array)/sizeof(size_t) ),
            _( "glide west 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_4Array, sizeof(pattern16_4Array)/sizeof(size_t) ),
            _( "glide west 16x16" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_3Array, sizeof(pattern4_3Array)/sizeof(size_t) ),
            _( "flip center 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_5Array, sizeof(pattern8_5Array)/sizeof(size_t) ),
            _( "flip center 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_7Array, sizeof(pattern16_7Array)/sizeof(size_t) ),
            _( "flip center 16x16" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_5Array, sizeof(pattern4_5Array)/sizeof(size_t) ),
            _( "invert&flip center 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_2Array, sizeof(pattern8_2Array)/sizeof(size_t) ),
            _( "invert&flip center 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_8Array, sizeof(pattern16_8Array)/sizeof(size_t) ),
            _( "invert&flip center 16x16" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_6Array, sizeof(pattern4_6Array)/sizeof(size_t) ),
            _( "2nd half 1st 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_6Array, sizeof(pattern8_6Array)/sizeof(size_t) ),
            _( "2nd half 1st 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_5Array, sizeof(pattern16_5Array)/sizeof(size_t) ),
            _( "2nd half 1st 16x16" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_4Array, sizeof(pattern4_4Array)/sizeof(size_t) ),
            _( "2nd half 1st&inv 1st 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_7Array, sizeof(pattern8_7Array)/sizeof(size_t) ),
            _( "2nd half 1st&inv 1st 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_6Array, sizeof(pattern16_6Array)/sizeof(size_t) ),
            _( "2nd half 1st&inv 1st 16x16" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern4_8Array, sizeof(pattern4_8Array)/sizeof(size_t) ),
            _( "sample&hold 4x4" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern8_8Array, sizeof(pattern8_8Array)/sizeof(size_t) ),
            _( "sample&hold 8x8" ) ) );
    patternArrayVector.push_back (
        std::make_pair (
            std::make_pair ( pattern16_2Array, sizeof(pattern16_2Array)/sizeof(size_t) ),
            _( "sample&hold 16x16" ) ) );

    presetCount = patternArrayVector.size();
}

void WarpGrid::getWarpKey ( std::string &key )
{
    std::vector<size_t> warpVector;

    getPositionVector ( warpVector );

    size_t warpVectorSize = warpVector.size();

    std::map<size_t, std::string> m;
    m.insert ( std::make_pair ( 0, "a") );
    m.insert ( std::make_pair ( 1, "b") );
    m.insert ( std::make_pair ( 2, "c") );
    m.insert ( std::make_pair ( 3, "d") );
    m.insert ( std::make_pair ( 4, "e") );
    m.insert ( std::make_pair ( 5, "f") );
    m.insert ( std::make_pair ( 6, "g") );
    m.insert ( std::make_pair ( 7, "h") );
    m.insert ( std::make_pair ( 8, "i") );
    m.insert ( std::make_pair ( 9, "j") );
    m.insert ( std::make_pair ( 10, "k") );
    m.insert ( std::make_pair ( 11, "l") );
    m.insert ( std::make_pair ( 12, "m") );
    m.insert ( std::make_pair ( 13, "n") );
    m.insert ( std::make_pair ( 14, "o") );
    m.insert ( std::make_pair ( 15, "p") );

    for ( size_t i = 0; i < warpVectorSize; i++ )
    {
        key += ( m.count ( warpVector.at ( i ) ) ) ? m [ warpVector.at ( i ) ] : "";
    }

    //std::cerr << "key = " << key << std::endl;
}

wxString WarpGrid::getPatternName ( size_t choice )
{
    choice = choice % presetCount;
    return patternArrayVector.at ( choice ). second;
}

void WarpGrid::preset ( size_t choice )
{
    clearAll();

    choice = choice % presetCount;

    size_t *patternArray = patternArrayVector.at( choice ).first.first;
    size_t patternArrayLength = patternArrayVector.at( choice ).first.second;

    //std::cerr << "\npatternArrayLength = " << patternArrayLength << std::endl;

    std::vector<size_t> positionVector;

    for ( size_t i = 0; i < patternArrayLength; i++ )
    {
        positionVector.push_back ( patternArray[ i ] );
    }

    BeginBatch();
    setPositionVector ( positionVector );
    EndBatch();
}
