#ifndef WAV16_H
#define WAV16_H

enum wav16States { WAV16_INIT, WAV16_HAS_DATA_IN, WAV16_HAS_DATA_OUT, WAV16_ERROR};

class Wav16
{
public:
    Wav16();
    ~Wav16();
    void clear ( ) {
        dataIn.clear();
        dataOut.clear();
    }
    void printInfo();
    bool read ( char *fname = NULL );
    bool write ( char *fname );
    bool writeRawData ( char *fname, const std::vector<double>& data );
    void generateSine ( double periods = 1760, double amplitude = 1.0, size_t frames = 176400, size_t channels = 2, size_t samplerate = 44100 );
    void getDataIn ( std::vector<double>& data ) {
        data = dataIn;
    }
    void getDataOut ( std::vector<double>& data ) {
        data = dataOut;
    }
    std::vector<double> *getDataInPtr ( ) {
        return &dataIn;
    }
    std::vector<double> *getDataOutPtr ( ) {
        return &dataOut;
    }
    int getState () {
        return wav16State;
    }
    size_t getChannels () {
        return ( size_t ) channels;
    }
    size_t getSamplerate () {
        return ( size_t ) samplerate;
    }
protected:
    int format, channels, samplerate;
    std::vector<double> dataIn, dataOut;
    int wav16State;
    bool isZeroCrossing ( int i );
    void setState ( int state ) {
        wav16State = state;
    }
};

#endif
