#ifndef WAV16SMASH_H
#define WAV16SMASH_H

#include <vector>
#include <string>

#include "wav16.h"
#include "smashmapper.h"
#include "slicevectortransformer.h"

class Wav16Smash : public Wav16
{
public:
    Wav16Smash ( bool *abort, std::string *message, size_t crossFadeRange = 1024 );
    ~Wav16Smash();
    bool smash ( size_t requestedSliceNo = 1 );
    void addSliceVectorTransformer (SliceVectorTransformer<double> *sliceVectorTransformer);
    void addSliceTransformer (SliceTransformer<double> *sliceTransformer);
    bool checkAbort();
    void clear();
    void clearSliceInfo();
    void clearEffectsInfo();
    bool getSlice ( size_t sliceNo, std::vector<double>& slice, size_t gateRange );
    void setSmashMapper ( SmashMapper<std::vector<double> > *sm ) {
        smashMapper = sm;
    };
    bool dataToSliceVectorCrossFade ( std::vector<double> *data, std::vector<std::vector<double> >& sliceVector, size_t requestedSliceNo );
    bool sliceVectorToDataCrossFade ( std::vector<std::vector<double> >& sliceVector, std::vector<double> *data );
private:
    void initSliceOffsetVector ( size_t requestedSliceNo );
    SmashMapper<std::vector<double> > *smashMapper;
    std::vector<SliceVectorTransformer<double> *> sliceVectorTransformerVector;
    std::vector<SliceTransformer<double> *> sliceTransformerVector;
    size_t crossFadeRange;
    bool *abortPtr;
    std::string *messagePtr;
    std::vector<std::pair<size_t, size_t> > sliceOffsetVector;
};

#endif
