#ifndef WAVE_WINDOW_H
#define WAVE_WINDOW_H

#include <wx/dcclient.h>
#include <wx/scrolwin.h>//exp

class WaveWindow : public wxScrolledWindow//wxWindow
{
public:
    WaveWindow( wxWindow *parent, int id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize );
    void set ( std::basic_string<double> *data );
    void drawCrossHair( const wxCoord& x, const wxCoord& y );
    void deleteCrossHair( const wxCoord& x, const wxCoord& y );
private:
    std::basic_string<wxPoint> points;
    std::basic_string<double> *data;
    int height, width;
    int heightMemory, widthMemory;
    void DoPaint( wxClientDC& dc );
    void OnIdle( wxIdleEvent& event );
    void OnPaint( wxPaintEvent& event);
    void OnSize( wxSizeEvent& event);
    void prepareDC ( wxClientDC& dc );
    void updatePoints( wxClientDC& dc );
    size_t idleCounter;
    DECLARE_EVENT_TABLE();
};

#endif
