#ifndef WRAPCSOUND_H
#define WRAPCSOUND_H

#include <string>
#include <wx/string.h>
#include <vector>
#include <utility>
#include <csound/csound.h>

class WrapCSound
{
public:
    WrapCSound( const wxString& cmd, const wxString& tempFile = wxEmptyString );
    ~WrapCSound();
    bool perform( std::vector<double> *leftChannel, std::vector<double> *rightChannel );
    bool performDisk( std::vector<double> *leftChannel, std::vector<double> *rightChannel );
    void setDoubleParameter ( const std::string& name, double value );
    void printMessages();
private:
    bool success;
    CSOUND *csound;
    std::vector<std::pair<std::string, double> > doubleParameterVector;
};

#endif

/*

#ifndef WRAPCSOUND_H
#define WRAPCSOUND_H

#include <string>
#include <wx/string.h>
#include <vector>
#include <utility>
#include <csound/csound.h>

class WrapCSound
{
public:
    WrapCSound( const wxString& cmd );
    ~WrapCSound();
    bool perform( std::vector<double> *leftChannel, std::vector<double> *rightChannel );
    bool performDisk( std::vector<double> *leftChannel, std::vector<double> *rightChannel );
    void setDoubleParameter ( const std::string& name, double value );
    void printMessages();
private:
    bool success;
    CSOUND *csound;
    std::vector<std::pair<std::string, double> > doubleParameterVector;
};

#endif

*/
