#ifndef __WXMSW__

#ifndef WRAPLIBMAD_H
#define WRAPLIBMAD_H

#include <string>
#include <vector>
#include "mad.h"

class dataBuffer {
public:
    unsigned char const *start;
    unsigned long length;
    std::vector<char> *pcmDataVector;
};

class WrapLibMad
{
public:
    bool mp3ToWav ( const std::string& fileIn, const std::string& fileOut );
private:
    int decode ( unsigned char const *start, unsigned long length, std::vector<char> *pcmDataVector );
    static inline signed int scale(mad_fixed_t sample);
    static enum mad_flow error(void *data, struct mad_stream *stream, struct mad_frame *frame);
    static enum mad_flow output(void *data, struct mad_header const *header, struct mad_pcm *pcm);
    static enum mad_flow input(void *data, struct mad_stream *stream);
};


#endif
#endif
